#include <iostream>
#include "scripts.h"
#include <time.h>
#include <vector>
#include <queue>
//#include <string>
#include <WinSock2.h>
#include <mysql.h>
#include "engine.h"
#include "data.h"
using namespace std;
#include "ou_thread.h"
using namespace openutils;
#include "XpzElite.h"
#include "XpzElite_Exclusive.h"
static bool XpzElite_Inited;
bool gameoverd = false;
#define uc unsigned char

const char *CFG = "xpzelite.ini";
const char *MAP_CFG = "map.ini";
const char *MOD_CFG = "mods.ini";
const char *XPZ_VER = "0.77";
const char *XPZ_BUILD = "77";

INIClass *ini_main;	// Main ini file
INIClass *ini_maps;	// Maps ini file
INIClass *ini_mods;	// Mods ini file

// Players Main Struct
Struct_Player players[128];

// Vehicles struct, one for each player
Struct_Bind bound_vehs[128];

// Honor information for each player
vector<Struct_Honor> hplayers;

// Channel Ranks
vector<Irc_Rank> chan_ranks;
vector<Irc_Rank> chan_ranks2;

// Request team change information for each player
vector<std::string> rtc_nod; // Requests from team Nod
vector<std::string> rtc_gdi; // Requests from team GDI
bool rtc_enable = true; // Is request team change enabled
int rtc_time = 300; // Request team change time (seconds)

// Main map settings
Struct_Map_Settings map_setting;

// Base defence struct, contains all the base defense buildings and information
vector<Struct_Base_Defense> base_defense_list;
queue<int> pleave;
GameObject *global;
Vector3 last_drop_pos;
int desNod = 0, desGDI = 0, SFPS = 60, fundGDI = 0, fundNod = 0;
static const std::string base64_chars = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
bool restartm = false;
bool force_idc = false;
bool first_obj = true;
std::string current_map = "None";
vector<Vector3> crate_list;

const double EXPOTENTIAL = 2.718281828;

/*-------------------------------------------------------------------------------------------------
									-=		Exp Formula		=-
-------------------------------------------------------------------------------------------------
Key: x-killer class, y-killed class
a-killer state, b-killed state
-------------------------------------------------------------------------------------------------
Andy's Master formula: ((2*y-x)*e^x)/10+2*x + (b^2/a)
-------------------------------------------------------------------------------------------------*/

const float exp_beacon = 100.0f;		// exp for defusing a beacon (depending on dmg repaired, it splits the exp to defusers)
const float exp_c4 = 25.0f;				// exp for defusing a c4
const float exp_repair = 0.05f;			// Repairing building, exp per point repaired
const float exp_repair_tank = 0.05f;	// Repairing tank, exp per point repaired
const int exp_veh_state = 4;			// used in the equation
const int exp_inf_state = 1;			// used within the equation

unsigned __int64 exp_table[1024];

/* =================================================================================================
Thread Definitions
------------------------------------------------------------------------------------------------- */

// ** Declarations **
// Main Classes
class Handler_Thread;
class MySQL_Thread;
class IRC_Thread;
class Renguard_Thread;
class TeamSpeak_Thread;
// Mutex's
Mutex2 Handler_Mutex("Handler");
Mutex2 MySQL_Mutex("MySQL");
Mutex2 IRC_Mutex("IRC");
Mutex2 Renguard_Mutex("Renguard");
Mutex2 TeamSpeak_Mutex("TeamSpeak");
Mutex2 Player_Mutex("pdb");
Mutex2 Honor_Mutex("hdb");
Mutex2 Bind_Mutex("bind");
Mutex2 Chanrank_Mutex("chanrank");
Mutex2 BaseDefence_Mutex("bd");
Mutex2 Crate_Mutex("crate");
Mutex2 Map_Settings_Mutex("ms");
// Threads
Thread *T_Handler = new Handler_Thread(100,"Handler");
Thread *T_MySQL = new MySQL_Thread(101,"MySQL");
Thread *T_IRC = new IRC_Thread(102,"IRC");
Thread *T_Renguard = new Renguard_Thread(103,"Renguard");
Thread *T_TeamSpeak = new TeamSpeak_Thread(104,"TeamSpeak");
Thread *T_XpzGuard = new XpzGuard_Thread(105,"XpzGuard");

unsigned __int64 iGetLevelExp(int iLevel) {
	unsigned __int64 iRet;
	if (iLevel == 0) return 0;
	iRet = iGetLevelExp(iLevel - 1) + iLevel * (50 + (iLevel * (iLevel / 17) * (iLevel / 17)));
	exp_table[iLevel] = iRet;
	return iRet;
}

void Handler_Thread::run() {
	speed = 250; // Default refresh speed
	Game::ConsoleU("Handler Thread has Started\n");
	char chan[1024], chan2[1024];
	ini_main->Get_String("irc","chan",0,chan,1024);
	ini_main->Get_String("irc","chan2",0,chan2,1024);
	iGetLevelExp(800);
	bool running = true;
	while (running == true) {
		int taskn = get_tasks();

		// Speed throttle
		/*if (taskn > 100) speed = 50;
		else if (taskn > 50) speed = 100;
		else if (taskn > 20) speed = 150;
		else speed = 250;*/

		if (taskn > 0) {
			task temp = pop_task();
			if (temp.id == 1) {
				// Display output
				Console_Output(temp.parms);
			} else if (temp.id == 2) {
				// Handel Inputs
				Console_Input(temp.parms);
			} else if (temp.id == 3) {
				// Prosses IRC Text (param-channel,param2-nick,param3-text)
				if (temp.parms3[0] == '!') {
					// Prosses command
					std::string buffer = temp.parms3, temp3;
					std::vector <std::string> words;
					int counter = 0;
					while (buffer.find(" ", 0) != std::string::npos) {
						size_t pos = buffer.find(" ", 0);
						temp3 = buffer.substr(0, pos);
						buffer.erase(0, pos + 1);
						words.push_back(temp3);
						counter++;
						if (counter > 2) break;
					}
					buffer.erase(buffer.length()-1,1);
					words.push_back(buffer);

					int channel = 0;
					if (stricmp(temp.parms, chan) == 0) channel = 1;
					else if (stricmp(temp.parms, chan2) == 0) channel = 2;
					int rank = Irc::Get_Irc_Rank(temp.parms2, channel);

					if (stricmp(words[0].c_str(),"!help") == 0) {
						XpzCmds::help(1,temp.parms2,words[1]);
					} else if (stricmp(words[0].c_str(),"!pl") == 0) {
						std::string nods, gdis, others;
						int max_players = GetMaxPlayerID();
						for (int i = 1; i <= max_players; i++) {
							if (Get_Player_Name_By_ID(i) != 0) {
								if (Get_Team(i) == 0) {
									nods += ", ";
									nods += Get_Player_Name_By_ID(i);
								} else if (Get_Team(i) == 1) {
									gdis += ", ";
									gdis += Get_Player_Name_By_ID(i);
								} else {
									others += ", ";
									others += Get_Player_Name_By_ID(i);
								}
							}
							char tmp_chr[1024];
							if (strlen(nods.c_str()) > 0) {
								nods.erase(0,2);
								sprintf(tmp_chr, "4Nod Players: %s", nods.c_str());
								Irc::Send_Chan2(channel, tmp_chr);
							}
							if (strlen(gdis.c_str()) > 0) {
								gdis.erase(0,2);
								sprintf(tmp_chr, "8GDI Players: %s", gdis.c_str());
								Irc::Send_Chan2(channel, tmp_chr);
							}
							if (strlen(others.c_str()) > 0) {
								others.erase(0,2);
								sprintf(tmp_chr, "Unteamed Players: %s", others.c_str());
								Irc::Send_Chan2(channel, tmp_chr);
							}
						}
					} else if (stricmp(words[0].c_str(),"!gi") == 0) {
						XpzCmds::game_info(0, channel);
					} else if (stricmp(words[0].c_str(),"!sgi") == 0) {
						XpzCmds::game_info(1, channel);
					} else if (stricmp(words[0].c_str(),"!maplist") == 0 || stricmp(words[0].c_str(),"!rotation") == 0) {
						XpzCmds::maps(0,1,channel);
					} else if (stricmp(words[0].c_str(),"!next") == 0 || stricmp(words[0].c_str(),"!nextmap") == 0 || stricmp(words[0].c_str(),"!shownext") == 0) {
						XpzCmds::maps(0,0,channel);
					} else if (stricmp(words[0].c_str(),"!mods") == 0 || stricmp(words[0].c_str(),"!showmods") == 0) {
						XpzCmds::showmods(0,channel);
					//} else if (stricmp(words[0].c_str(),"!kicks") == 0 || stricmp(words[0].c_str(),"!logsearch") == 0) {
					} else if (stricmp(words[0].c_str(),"!rules") == 0 || stricmp(words[0].c_str(),"!rule") == 0) {
						XpzCmds::rules(0, false);
					} else if (stricmp(words[0].c_str(),"!maprules") == 0 || stricmp(words[0].c_str(),"!maprule") == 0) {
						XpzCmds::rules(0, true);
					} else if (stricmp(words[0].c_str(),"!minelimit") == 0) {
						XpzCmds::mine_limit(0,channel);
					} else if (stricmp(words[0].c_str(),"!rg") == 0 || stricmp(words[0].c_str(),"!renguard") == 0) {
						XpzCmds::rg_check(0, Get_Player_ID(Get_Part_Name(words[1].c_str())), channel);
					} else if (stricmp(words[0].c_str(),"!bl") == 0 || stricmp(words[0].c_str(),"!buildings") == 0) {
						XpzCmds::buildings(-1,channel);
					} else if (stricmp(words[0].c_str(),"!ve") == 0 || stricmp(words[0].c_str(),"!vehicles") == 0) {
						XpzCmds::vehicles(channel);
					}

					if (rank > 0) {
						if (stricmp(words[0].c_str(),"!qkick") == 0) {
							std::string reason;
							if (counter > 1) {
								reason = words[2];
								if (counter > 2) {
									reason += " ";
									reason += words[3];
								}
								XpzCmds::kick(temp.parms2,reason,0,Get_Player_ID(Get_Part_Name(words[1].c_str())));
							} else Irc::Send_Notice(temp.parms2, "Syntax: !qkick <name> <reason>");
						} else if (stricmp(words[0].c_str(),"!msg") == 0) {
							if (counter > 0) {
								std::string msg;
								msg = words[1];
								if (counter > 1) {
									msg += " ";
									msg += words[2];
								}
								if (counter > 2) {
									msg += " ";
									msg += words[3];
								}
								XpzCmds::msg(0,temp.parms2,msg);
							}
						} else if (stricmp(words[0].c_str(),"!page") == 0) {
							if (counter > 1) {
								std::string msg;
								msg = words[2];
								if (counter > 2) {
									msg += " ";
									msg += words[3];
								}
								XpzCmds::page(temp.parms2, words[1].c_str(), msg, channel);
							}
						} else if (stricmp(words[0].c_str(),"!ppage") == 0) {
							if (counter > 1) {
								std::string msg;
								msg = words[2];
								if (counter > 2) {
									msg += " ";
									msg += words[3];
								}
								XpzCmds::ppage(0,temp.parms2,Get_Player_ID(Get_Part_Name(words[1].c_str())),msg,channel);
							}
						} else if (stricmp(words[0].c_str(),"!tmsg") == 0) {
							if (counter > 0) {
								std::string msg;
								bool halt = false;
								if (stricmp(words[1].c_str(), "nod") == 0) {
									words[1] = "0";
								} else if (stricmp(words[1].c_str(), "gdi") == 0) {
									words[1] = "1";
								} else {
									halt = true;
								}

								if (halt == false) {
									msg = "tpage ";
									msg += words[1];
									if (counter > 1) {
										msg += " ";
										msg += words[2];
									}
									if (counter > 2) {
										msg += " ";
										msg += words[3];
									}
									Game::ConsoleI(msg.c_str());
								}
							}
						} else if (stricmp(words[0].c_str(),"!kick") == 0) {
							std::string reason;
							if (counter > 1) {
								reason = words[2];
								if (counter > 2) {
									reason += " ";
									reason += words[3];
								}
								XpzCmds::kick(temp.parms2,reason,1,Get_Player_ID(Get_Part_Name(words[1].c_str())),(24*60*60));
							} else Irc::Send_Notice(temp.parms2,"Syntax: !kick <name> <reason>)");
						} else if (stricmp(words[0].c_str(),"!tban") == 0) {
							std::string reason;
							if (counter > 2) {
								reason = words[3];
								XpzCmds::kick(Get_Player_Name_By_ID((int)temp.parms4),reason,1,Get_Player_ID(Get_Part_Name(words[1].c_str())),atoi(words[2].c_str())*60*60);
							} else Irc::Send_Notice(temp.parms2,"Syntax: !tban <name> <hours> <reason>)");
						} else if (stricmp(words[0].c_str(),"!idc") == 0) {
							char pbc[1024];
							sprintf(pbc, "Forced identification for moderators is %s.", force_idc == false ? "DISABLED" : "ENABLED");
							Irc::Send_Chan2(channel, pbc);
						}
					}

					if (rank > 1) {
						if (stricmp(words[0].c_str(),"!amsg") == 0) {
							if (counter > 0) {
								std::string msg;
								msg = words[1];
								if (counter > 1) {
									msg += " ";
									msg += words[2];
								}
								if (counter > 2) {
									msg += " ";
									msg += words[3];
								}
								XpzCmds::msg(1,temp.parms2,msg);
							}
						} else if (stricmp(words[0].c_str(),"!pi") == 0) {
							if (strlen(words[1].c_str()) > 0) {
								XpzCmds::player_info(0,temp.parms2,Get_Player_ID(Get_Part_Name(words[1].c_str())));
							}
						} else if (stricmp(words[0].c_str(),"!pamsg") == 0) {
							if (counter > 1) {
								std::string msg;
								msg = words[2];
								if (counter > 2) {
									msg += " ";
									msg += words[3];
								}
								XpzCmds::ppage(1, temp.parms2, Get_Player_ID(Get_Part_Name(words[1].c_str())), msg,channel);
							}
						}
					}
					if (rank > 2) {
						if (stricmp(words[0].c_str(),"!unban") == 0) {
							if (counter > 0) XpzCmds::unban(2,temp.parms2,words[1].c_str());
							else Irc::Send_Notice(temp.parms2, "Syntax: !unban <name>");
						} else if (stricmp(words[0].c_str(),"!ban") == 0) {
							std::string reason;
							if (counter > 1) {
								reason = words[2];
								if (counter > 2) {
									reason += " ";
									reason += words[3];
								}
								XpzCmds::kick(temp.parms2,reason,2,words[1].c_str());
							} else Irc::Send_Notice(temp.parms2, "Syntax: !ban <name> <reason>");
						} else if (stricmp(words[0].c_str(),"!unbanip") == 0) {
							if (counter > 0) XpzCmds::unban(1,temp.parms2,words[1].c_str());
							else Irc::Send_Notice(temp.parms2, "Syntax: !unbanip <ip>");
						} else if (stricmp(words[0].c_str(),"!banip") == 0) {
							std::string reason;
							if (counter > 1) {
								reason = words[2];
								if (counter > 2) {
									reason += " ";
									reason += words[3];
								}
								XpzCmds::kick(temp.parms2,reason,4,words[1].c_str());
							} else Irc::Send_Notice(temp.parms2, "Syntax: !banip <ip> <reason>");
						} else if (stricmp(words[0].c_str(),"!atm") == 0 || stricmp(words[0].c_str(),"!addtempmod") == 0) {
							if (Get_Part_Names(words[1].c_str()) > 0) {
								int pid = Get_Player_ID(Get_Part_Name(words[1].c_str()));
								XpzMod::promote(pid, 1, "Null");
							} else {
								char out[1024];
								sprintf(out, "%s could not be found", words[1].c_str());
								Irc::Send_Chan2(channel, out);
							}
						} else if (stricmp(words[0].c_str(),"!dtm") == 0 || stricmp(words[0].c_str(),"!deltempmod") == 0) {
							char out[1024];
							if (Get_Part_Names(words[1].c_str()) > 0) {
								int pid = Get_Player_ID(Get_Part_Name(words[1].c_str()));
								Struct_Player temp_pdb;
								Game::Get_Player(pid, &temp_pdb);
								if (temp_pdb.mod == 1) XpzMod::demote(pid);
								else {
									sprintf(out, "%s is not an VIP.", Get_Player_Name_By_ID(pid));
									Irc::Send_Chan2(channel, out);
								}
							} else {
								sprintf(out, "%s could not be found", words[1].c_str());
								Irc::Send_Chan2(channel, out);
							}
						} else if (stricmp(words[0].c_str(),"!gameover") == 0) {
							if (strcmp(words[1].c_str(),"NOW") == 0) {
								XpzCmds::msg(1,temp.parms2,"This map has been terminated. Loading next map...");
								Game::ConsoleI("gameover");
							}
						} else if (stricmp(words[0].c_str(),"!forcetc") == 0) {
							GameObject *tc = Get_Part_Name(words[1].c_str());
							char temp2[1024];
							if (tc) {
								sprintf(temp2, "The player %s has changed teams and joined %s.",Get_Player_Name(tc),Get_Team(Get_Player_ID(tc)) == 0 ? "GDI" : "Nod");
								Irc::Send_Chan2(channel,temp2);
								sprintf(temp2, "team %d", Get_Player_ID(tc));
								Game::ConsoleI(temp2);
							} else {
								sprintf(temp2, "The player %s cannot be found.",words[1].c_str());
								Irc::Send_Chan2(channel,temp2);
							}
						} else if (stricmp(words[0].c_str(),"!forcetc2") == 0) {
							GameObject *tc = Get_Part_Name(words[1].c_str());
							char temp2[1024];
							if (tc) {
								sprintf(temp2, "The player %s has changed teams and joined %s.",Get_Player_Name(tc),Get_Team(Get_Player_ID(tc)) == 0 ? "GDI" : "Nod");
								Irc::Send_Chan2(channel,temp2);
								sprintf(temp2, "team2 %d", Get_Player_ID(tc));
								Game::ConsoleI(temp2);
							} else {
								sprintf(temp2, "The player %s cannot be found.",words[1].c_str());
								Irc::Send_Chan2(channel,temp2);
							}
						}
					}
					if (rank > 3) {
						if (stricmp(words[0].c_str(),"!restart") == 0) {
							if (strcmp(words[1].c_str(),"NOW") == 0) {
								XpzCmds::msg(1,temp.parms2,"Server is now restarting... Please rejoin in 2 minutes.");
								Game::ConsoleI("restart");
							}
						} else if (stricmp(words[0].c_str(),"!restartm") == 0 || stricmp(words[0].c_str(),"!restartmap") == 0) {
							XpzCmds::msg(0,"NULL","Map Restart Authorized. The server will restart next map.");
							restartm = true;
						} else if (stricmp(words[0].c_str(),"!crestart") == 0 || stricmp(words[0].c_str(),"!cancelrestart") == 0) {
							XpzCmds::msg(0,"NULL","Map Restart Halted. The server will no longer restart after this map.");
							restartm = false;
						} else if (stricmp(words[0].c_str(),"!forceidc") == 0) {
							if (counter > 0) {
								if (stricmp("off", words[1].c_str()) == 0) {
									force_idc = false;
									XpzCmds::msg(0,"NULL","Administrator has DEACTIVATED forced identification for all moderators.");
								} else if (stricmp("on", words[1].c_str()) == 0) {
									force_idc = true;
									XpzCmds::msg(0,"NULL","Administrator has ACTIVATED forced identification for all moderators.");
								} else Irc::Send_Notice(temp.parms2, "Syntax: !forceidc <on/off>");
							} else Irc::Send_Notice(temp.parms2, "Syntax: !forceidc <on/off>");
						} else if (stricmp(words[0].c_str(),"!console") == 0) {
							if (counter > 0) {
								std::string rea = words[1];
								if (counter > 1) {
									rea += " ";
									rea += words[2];
									if (counter > 2) {
										rea += " ";
										rea += words[3];
									}
								}
								char msg_tmp[1024];
								sprintf(msg_tmp,"Console command <%s> was sent!", rea.c_str());
								Game::ConsoleI(rea.c_str());
								Irc::Send_Chan2(channel, msg_tmp, true);
							}
						}
					}
				}
			} else if (temp.id == 4) {
				// Prosses's InGame Text (param1-message,param2-nothing,param3-nothing,param4-player id,param5-msg type)
				int pid = (int)temp.parms4;
				char tmp_msg[2048];
				GameObject *player = Get_GameObj(pid);
				if (temp.parms5 == 2) {
					sprintf(tmp_msg, "%s%s: %s", Commands->Get_Player_Type(player) == 0 ? "04" : "08", Get_Player_Name_By_ID(pid), temp.parms);
					Irc::Send_Chan2(0, tmp_msg);
				} else if (temp.parms5 == 1) {
					sprintf(tmp_msg, "06[Team] %s%s: %s", Commands->Get_Player_Type(player) == 0 ? "04" : "08", Get_Player_Name_By_ID(pid), temp.parms);
					Irc::Send_Chan2(2, tmp_msg);
				}

				std::string buffer = temp.parms, tmp;
				std::vector <std::string> words;
				int counter = 0;
				while (buffer.find(" ", 0) != std::string::npos) {
					size_t pos = buffer.find(" ", 0);
					tmp = buffer.substr(0, pos);
					buffer.erase(0, pos + 1);
					words.push_back(tmp);
					counter++;
					if (counter > 3) break;
				}
				words.push_back(buffer);

				if (temp.parms[0] == '!') {
					Struct_Player temp_pdb;
					Game::Get_Player(pid, &temp_pdb);
					int rank = temp_pdb.mod;
					if (stricmp(words[0].c_str(),"!help") == 0) {
						XpzCmds::help(0,temp_pdb.name,words[1]);
					} else if (stricmp(words[0].c_str(),"!share") == 0) {
						XpzCmds::donate(player, player, atoi(words[1].c_str()), true);
					} else if (stricmp(words[0].c_str(),"!poll") == 0) {
					} else if (stricmp(words[0].c_str(),"!vote") == 0) {
					} else if (stricmp(words[0].c_str(),"!honor") == 0) {
						Struct_Player p_temp;
						Game::Get_Player(pid, &p_temp);
						char o_msg[1024];
						sprintf(o_msg, "Honor Level: %d  -  Current Experiance: %I64d  -  Experiance needed to level: %I64d", p_temp.honor, p_temp.exp, exp_table[p_temp.honor] - p_temp.exp);
						XpzCmds::ppage(0,pid,o_msg);
					} else if (stricmp(words[0].c_str(),"!donate") == 0) {
						GameObject *obj = Get_Part_Name(words[1].c_str());
						XpzCmds::donate(player, obj, atoi(words[2].c_str()), false);
					} else if (stricmp(words[0].c_str(),"!mines") == 0 || stricmp(temp.parms,"!c4") == 0 || stricmp(temp.parms,"!minelimit") == 0) {
						XpzCmds::mine_limit(1,0);
					} else if (stricmp(words[0].c_str(),"!rules") == 0 || stricmp(words[0].c_str(),"!rule") == 0) {
						XpzCmds::rules(1, false);
					} else if (stricmp(words[0].c_str(),"!maprules") == 0 || stricmp(words[0].c_str(),"!maprule") == 0) {
						XpzCmds::rules(1, true);
					} else if (stricmp(words[0].c_str(),"!mods") == 0 || stricmp(temp.parms,"!showmods") == 0) {
						XpzCmds::showmods(1,0);
					} else if (stricmp(words[0].c_str(),"!rebuy") == 0) {
					} else if (stricmp(words[0].c_str(),"!selltank") == 0) {
					} else if (stricmp(words[0].c_str(),"!bind") == 0 || stricmp(temp.parms,"!b") == 0) {
						GameObject *tank = Get_Vehicle(player);
						if (tank != 0) Commands->Send_Custom_Event(player, tank, CUSTOM_XPZ_EVENT_BIND, 0, 0);
						else XpzCmds::ppage(0, pid, "You must be in a vehicle to use this command.");
					} else if (stricmp(words[0].c_str(),"!unbind") == 0 || stricmp(temp.parms,"!ub") == 0) {
						GameObject *tank = Commands->Find_Object(Game::Get_Veh_Owner((int)temp.parms4));
						if (tank != 0) Commands->Send_Custom_Event(player, tank, CUSTOM_XPZ_EVENT_UNBIND, 0, 0);
						else XpzCmds::ppage(0,pid,"You must have a vehicle bound to you before using this command!");
					} else if (stricmp(words[0].c_str(),"!lock") == 0 || stricmp(temp.parms,"!l") == 0 || stricmp(temp.parms,"!bindlock") == 0 || stricmp(temp.parms,"!bl") == 0) {
						GameObject *tank = Get_Vehicle(player);
						if (tank != 0) Commands->Send_Custom_Event(player, tank, CUSTOM_XPZ_EVENT_LOCK, 0, 0);
						else XpzCmds::ppage(0, pid, "You must be in a vehicle to use this command.");
					} else if (stricmp(words[0].c_str(),"!free") == 0) {
						GameObject *tank = Commands->Find_Object(Game::Get_Veh_Owner((int)temp.parms4));
						if (Get_Vehicle_Driver(tank) == player) Force_Occupants_Exit(tank);
						if (tank != 0) Commands->Send_Custom_Event(player, tank, CUSTOM_XPZ_EVENT_FREE, 0, 0);
						else XpzCmds::ppage(0,pid,"You must have a vehicle bound to you before using this command!");
					} else if (stricmp(words[0].c_str(),"!vkick") == 0) {
					} else if (stricmp(words[0].c_str(),"!vstats") == 0) {
					} else if (stricmp(words[0].c_str(),"!rtc") == 0 || stricmp(temp.parms,"!requesttc") == 0 || stricmp(temp.parms,"!requestteamchange") == 0) {
						if (rtc_enable == true) {
							int team = Get_Team(pid);
							std::string name = Get_Player_Name_By_ID(pid);
							char mss[1024];
							if (team == 0) {
								// Player is Nod, check GDI
								if (rtc_gdi.size() > 0) {
									// There is players on the opposite list, change team
									std::string changer = rtc_gdi.front();
									sprintf(mss, "team2 %d %d", pid, team == 0 ? 1 : 0);
									Game::ConsoleI(mss);
									sprintf(mss, "team2 %d %d", Get_Player_ID(Get_GameObj_By_Player_Name(changer.c_str())), team);
									Game::ConsoleI(mss);
									sprintf(mss, "%s and %s have switched teams!", changer.c_str(), name.c_str());
									XpzCmds::msg(0, "Null", mss);
									Game::Defuse_All(changer);
									Game::Defuse_All(name);
									rtc_gdi.erase(rtc_gdi.begin());
								} else {
									// *check not in list already
									if (Game::within_rtc(name, team) == 0) {
										Struct_Player pp;
										sprintf(mss, "%s has requested a team change. If any %s wishes to change teams, just use the !rtc command.", name.c_str(), team == 0 ? "GDI" : "Nod");
										XpzCmds::msg(0, "Null", mss);
										rtc_nod.push_back(name);
									} else XpzCmds::ppage(0,pid, "Your request is already listed.");
								}
							} else {
								// Player is GDI, check Nod
								if (rtc_nod.size() > 0) {
									// There is players on the opposite list, change team
									std::string changer = rtc_nod.front();
									sprintf(mss, "team2 %d %d", pid, team == 0 ? 1 : 0);
									Game::ConsoleI(mss);
									sprintf(mss, "team2 %d %d", Get_Player_ID(Get_GameObj_By_Player_Name(changer.c_str())), team);
									Game::ConsoleI(mss);
									sprintf(mss, "%s and %s have switched teams!", changer.c_str(), name);
									XpzCmds::msg(0, "Null", mss);
									Game::Defuse_All(changer);
									Game::Defuse_All(name);
									rtc_nod.erase(rtc_nod.begin());
								} else {
									// *check not in list already
									if (Game::within_rtc(name, team) == 0) {
										sprintf(mss, "%s has requested a team change. If any %s wishes to change teams, just use the !rtc command.", name.c_str(), team == 0 ? "GDI" : "Nod");
										XpzCmds::msg(0, "Null", mss);
										rtc_gdi.push_back(name);
									} else XpzCmds::ppage(0,pid, "Your request is already listed.");
								}
							}
						} else XpzCmds::ppage(0, pid, "Request team change is not allowed at this time, please try again later.");
					} else if (stricmp(words[0].c_str(),"!rtclist") == 0) {
						// Lists the players on the request team change list
						if (rtc_enable == true) {
							std::string list_gdi = "None";
							std::string list_nod = "None";
							std::string list_gdi1, list_nod1;

							// Builds GDI names list
							for (unsigned int i=0; i<rtc_gdi.size(); i++) {
								if (i == 0) list_gdi = rtc_gdi[i];
								else {
									list_gdi += ", ";
									list_gdi += rtc_gdi[i];
								}
							}

							// Builds Nod names list
							for (unsigned int i=0; i<rtc_nod.size(); i++) {
								if (i == 0) list_nod = rtc_nod[i];
								else {
									list_nod += ", ";
									list_nod += rtc_nod[i];
								}
							}

							list_gdi1 = "GDI players who are requesting a team change: ";
							list_gdi1 += list_gdi;
							list_nod1 = "Nod players who are requesting a team change: ";
							list_nod1 += list_nod;
							XpzCmds::msg(0,"Null",list_gdi1.c_str());
							XpzCmds::msg(0,"Null",list_nod1.c_str());
						} else XpzCmds::ppage(0, pid, "Request team change is not allowed at this time, please try again later.");
					} else if (stricmp(words[0].c_str(),"!commanders") == 0) {
					} else if (stricmp(words[0].c_str(),"!fund") == 0) {
					} else if (stricmp(words[0].c_str(),"!next") == 0 || stricmp(temp.parms,"!nextmap") == 0 || stricmp(temp.parms,"!showmext") == 0) {
						XpzCmds::maps(1,0,0);
					} else if (stricmp(words[0].c_str(),"!maps") == 0 || stricmp(temp.parms,"!maplist") == 0 || stricmp(temp.parms,"!rotation") == 0) {
						XpzCmds::maps(1,1,0);
					}

					if (rank > 0) {
						if (stricmp(words[0].c_str(),"!qkick") == 0) {
							std::string reason;
							if (counter > 1) {
								reason = words[2];
								if (counter > 2) {
									reason += " ";
									reason += words[3];
								}
								XpzCmds::kick(Get_Player_Name_By_ID((int)temp.parms4),reason,0,Get_Player_ID(Get_Part_Name(words[1].c_str())));
							} else {
								XpzCmds::ppage(0,(int)temp.parms4,"Both a name and reason are to be suppled. (!qkick <name> <reason>)");
							}
						} else if (stricmp(words[0].c_str(),"!kill") == 0) {
						} else if (stricmp(words[0].c_str(),"!kick") == 0) {
							std::string reason;
							if (counter > 1) {
								reason = words[2];
								if (counter > 2) {
									reason += " ";
									reason += words[3];
								}
								XpzCmds::kick(Get_Player_Name_By_ID((int)temp.parms4),reason,1,Get_Player_ID(Get_Part_Name(words[1].c_str())),(24*60*60));
							} else XpzCmds::ppage(0,(int)temp.parms4,"Both a name and reason are to be suppled. (!kick <name> <reason>)");
						} else if (stricmp(words[0].c_str(),"!tban") == 0) {
							std::string reason;
							if (counter > 2) {
								reason = words[3];
								XpzCmds::kick(Get_Player_Name_By_ID((int)temp.parms4),reason,1,Get_Player_ID(Get_Part_Name(words[2].c_str())),(atoi(words[1].c_str())*60*60));
							} else XpzCmds::ppage(0,(int)temp.parms4,"All parameters; name, reason and time(hours) are to be suppled. (!tban <nick> <hours> <reason>)");
						} else if (stricmp(words[0].c_str(),"!idc") == 0) {
							char pbc[1024];
							sprintf(pbc, "Forced identification for moderators is %s.", force_idc == false ? "DISABLED" : "ENABLED");
							XpzCmds::ppage(0, pid, pbc);
						}
					}

					if (rank > 2) {
						if (stricmp(words[0].c_str(),"!ban") == 0 || stricmp(temp.parms,"!kb") == 0 || stricmp(temp.parms,"!kickban") == 0) {
							std::string reason;
							if (counter > 1) {
								reason = words[2];
								if (counter > 2) {
									reason += " ";
									reason += words[3];
								}
								XpzCmds::kick(Get_Player_Name_By_ID((int)temp.parms4),reason,2,Get_Player_ID(Get_Part_Name(words[1].c_str())));
							} else XpzCmds::ppage(0,(int)temp.parms4,"Both a name and reason are to be suppled. (!qkick <name> <reason>)");
						} else if (stricmp(words[0].c_str(),"!unban") == 0) {
							XpzCmds::unban(2,Get_Player_Name_By_ID((int)temp.parms4),words[1].c_str());
						} else if (stricmp(words[0].c_str(),"!atm") == 0 || stricmp(temp.parms,"!addtempmod") == 0) {
							if (counter > 0) {
								GameObject *target = Get_Part_Name(words[1].c_str());
								if (target != 0) XpzMod::promote(Get_Player_ID(target),1);
								else XpzCmds::ppage(0,(int)temp.parms4,"A valid name must be suppled. (!atm <nick>)");
							} else XpzCmds::ppage(0,(int)temp.parms4,"A valid name must be suppled. (!atm <nick>)");
						} else if (stricmp(words[0].c_str(),"!dtm") == 0 || stricmp(temp.parms,"!deltempmod") == 0) {
							if (counter > 0) {
								GameObject *target = Get_Part_Name(words[1].c_str());
								if (target != 0) XpzMod::demote(Get_Player_ID(target));
								else XpzCmds::ppage(0,(int)temp.parms4,"A valid name must be suppled. (!dtm <nick>)");
							} else XpzCmds::ppage(0,(int)temp.parms4,"A valid name must be suppled. (!dtm <nick>)");
						} else if (stricmp(words[0].c_str(),"!gameover") == 0) {
							if (counter > 0) {
								if (strcmp(words[1].c_str(),"NOW") == 0) Game::ConsoleI("gameover");
								else XpzCmds::ppage(0,(int)temp.parms4,"Format is !gameover NOW. This is case sensitive (need to do the big letters)");
							}
						} else if (stricmp(words[0].c_str(),"!forcetc") == 0) {
							GameObject *tc = Get_Part_Name(words[1].c_str());
							char temp2[1024];
							if (tc) {
								sprintf(temp2, "team %d", Get_Player_ID(tc));
								Game::ConsoleI(temp2);
							} else {
								sprintf(temp2, "The player %s cannot be found.",words[1].c_str());
								XpzCmds::ppage(0,pid,temp2);
							}
						} else if (stricmp(words[0].c_str(),"!forcetc2") == 0) {
							GameObject *tc = Get_Part_Name(words[1].c_str());
							char temp2[1024];
							if (tc) {
								sprintf(temp2, "team2 %d", Get_Player_ID(tc));
								Game::ConsoleI(temp2);
							} else {
								sprintf(temp2, "The player %s cannot be found.",words[1].c_str());
								XpzCmds::ppage(0,pid,temp2);
							}
						}
					}

					if (rank > 3) {
						if (stricmp(words[0].c_str(),"!restart") == 0) {
							if (strcmp(words[1].c_str(),"NOW") == 0) {
								XpzCmds::msg(1,Get_Player_Name_By_ID(pid),"Server is now restarting... Please rejoin in 2 minutes.");
								Game::ConsoleI("restart");
							} else XpzCmds::ppage(0,(int)temp.parms4,"Format is !gameover NOW. This is case sensitive (need to do the big letters)");
						} else if (stricmp(words[0].c_str(),"!restartm") == 0 || stricmp(words[0].c_str(),"!restartmap") == 0) {
							XpzCmds::msg(0,"NULL","Map Restart Authorized. The server will restart next map.");
							restartm = true;
						} else if (stricmp(words[0].c_str(),"!crestart") == 0 || stricmp(words[0].c_str(),"!cancelrestart") == 0) {
							XpzCmds::msg(0,"NULL","Map Restart Halted. The server will no longer restart after this map.");
							restartm = false;
						} else if (stricmp(words[0].c_str(),"!addcrate") == 0 || stricmp(words[0].c_str(),"!addbd") == 0) {
							Vector3 loc = Commands->Get_Position(Get_GameObj(pid));
							char the_x[32], the_y[32], the_z[32];
							sprintf(the_x, "%f", loc.X);
							sprintf(the_y, "%f", loc.Y);
							sprintf(the_z, "%f", loc.Z);
							int type = 0;
							if (stricmp(words[0].c_str(),"!addbd") == 0) type = 1;
							if (stricmp(words[0].c_str(),"!addcrate") == 0) type = 2;
							T_MySQL->add_task(task(13, the_x, the_y, the_z, 0, type));
							char mes[1024];
							sprintf(mes, "Your location [X:%s,Y:%s,Z:%s] has been saved as a ", the_x, the_y, the_z, type == 1 ? "Base Defense Location" : "Create Spawn Location");
							XpzCmds::ppage(0, pid, mes);
						}
					}
				}
			} else if (temp.id == 5) {
				// Task 5, spawn base defence
				int enabled = 0;
				if (wait("ms") == true) {
					if (map_setting.loaded == 2) {
						int bd_max = map_setting.bd_num;
						if (map_setting.bd_chance <= Game::true_rand(1,100)) {
							enabled = 1;
							map_setting.bd_active = true;
							if (wait("bd") == true) {
								for (int i = 0; i <= bd_max; i++) {
									base_defense_list[i].enable();
									base_defense_list[i].build();
								}
								release("bd");
							}
						} else {
							enabled = -1;
						}
					} else if (map_setting.loaded == -1) {
						enabled = -1;
					} else if (map_setting.loaded == 1) {
						T_Handler->add_task(task(5));
					}
					release("ms");
				}
				//char msg_tmp[1024];
				//if (enabled == -1) {
				//	sprintf(msg_tmp, "msg Extra base defenses for %s, have been Disabled.", Game::phrase_map(The_Game()->MapName));
				//	Console_Input(msg_tmp);
				//} else if (enabled == 1) {
				//	sprintf(msg_tmp, "msg Extra base defenses for %s, have been Enabled.", Game::phrase_map(The_Game()->MapName));
				//	Console_Input(msg_tmp);
				//}
			} else if (temp.id == 6) {
				Struct_Player p_temp;
				Game::Get_Player(temp.parms5, &p_temp);
				if (p_temp.exp_pending != 0) {
					char message[1024];
					if (p_temp.honor == 0) p_temp.honor = 1;
					sprintf(message, " +%d exp point(s)  ", int(p_temp.exp_pending));
					Display_Int_Player(Get_GameObj(temp.parms5),Get_Team(temp.parms5),message);
					p_temp.exp += (unsigned __int64)p_temp.exp_pending;
					if (p_temp.exp >= exp_table[p_temp.honor]) {
						// Level up
						p_temp.honor++;
						sprintf(message, " You Leveled Up to Honor %d!  ", int(p_temp.exp_pending));
						Display_Int_Player(Get_GameObj(temp.parms5),Get_Team(temp.parms5),message);
						if (p_temp.honor > 49) {
							sprintf(message, "msg [LevelUp] %s has leveled to honor %d!", p_temp.name.c_str(), p_temp.honor);
							Console_Input(message);
						}

						sprintf(message, "PPAGE %d [LevelUp] Congratulations! You have leveled to honor %d!", temp.parms5, p_temp.honor);
						Console_Input(message);
					}
					Struct_Honor h_temp = Game::Get_Honor(p_temp.name);
					h_temp.vet_point += p_temp.exp_pending;
					Game::Set_Honor(p_temp.name, h_temp);
					p_temp.exp_pending = 0;
					Game::Set_Player(temp.parms5, p_temp);
				}
			}
		}
		sleep(speed);
	}
}

void MySQL_Thread::run() {
	speed = 500; // Default refresh speed
	Game::ConsoleU("MySQL Thread has Started\n");
	char db_main[128], ip[128], full_ip[128], user[128], pass[128];
	int port = ini_main->Get_Int("db","port",3306);
	ini_main->Get_String("db","main","XpzElite",db_main,128);
	ini_main->Get_String("db","ip",0,ip,128);
	ini_main->Get_String("db","user","root",user,128);
	ini_main->Get_String("db","pass",0,pass,128);
	sprintf(full_ip, "%s:%d", ip, port);
	
	char sql[2048], sql2[2048], prefex[128], serv_ip[16];
	XpzBase::ipNumToString(The_Game()->IP, serv_ip);
	ini_main->Get_String("main", "prefex", "XpzElite", prefex, 128);
	time_t seconds = time (NULL);

	MYSQL *db = mysql_init(NULL);
	connect(db,ip,user,pass,db_main,port);

	sprintf(sql, "DROP TABLE IF EXISTS `%s_building`", prefex, prefex);
	mysql_query(db, sql);
	sprintf(sql, "DROP TABLE IF EXISTS `%s_players`", prefex, prefex);
	mysql_query(db, sql);
	sprintf(sql, "CREATE TABLE IF NOT EXISTS `%s_building` (`id` int(11) NOT NULL default '0', `name` text NOT NULL, `side` int(11) NOT NULL default '0', `max_hp` int(11) NOT NULL default '0', `max_sp` int(11) NOT NULL default '0', `now_hp` int(11) NOT NULL default '0', `now_sp` int(11) NOT NULL default '0') ENGINE=MyISAM DEFAULT CHARSET=latin1", prefex);
	mysql_query(db, sql);
	sprintf(sql, "CREATE TABLE IF NOT EXISTS `%s_players` (`id` int(11) NOT NULL default '0', `name` text NOT NULL, `max_hp` int(11) NOT NULL default '0', `max_sp` int(11) NOT NULL default '0', `now_hp` int(11) NOT NULL default '0', `now_sp` int(11) NOT NULL default '0', `credit` int(11) NOT NULL default '0', `score` int(11) NOT NULL default '0', `kills` int(11) NOT NULL default '0', `deaths` int(11) NOT NULL default '0', `preset` text NOT NULL, `side` int(11) NOT NULL default '0') ENGINE=MyISAM DEFAULT CHARSET=latin1", prefex);
	mysql_query(db, sql);
	sprintf(sql, "DELETE FROM `servers` WHERE CONVERT(`prefex` USING utf8) = '%s'", prefex);
	mysql_query(db, sql);
	sprintf(sql, "INSERT INTO `servers` VALUES ('%s', '%s', '%s',", WideCharToChar(The_Game()->GameTitle.m_Buffer), WideCharToChar(The_Game()->Owner.m_Buffer), The_Game()->MapName);
	sprintf(sql, "%s %d, %d, %d, %d, %d, %d, %d, %d," , sql, Tally_Team_Size(1), Tally_Team_Size(0), int(Get_Team_Score(1)), int(Get_Team_Score(0)), int(The_Game()->MaxPlayers), ini_main->Get_Int("irc", "enable", 0), ini_main->Get_Int("rg", "enable", 0), ini_main->Get_Int("ts", "enable", 0));
	sprintf(sql, "%s %d, 1, %d, '%s', '%s')", sql, int(seconds), ini_main->Get_Int("main", "interval", 60), serv_ip, prefex);
	mysql_query(db, sql);

	bool running = true;
	while (running == true) {
		int taskn = get_tasks();

		// Speed throttle
		if (taskn > 100) speed = 50;
		else if (taskn > 50) speed = 125;
		else if (taskn > 20) speed = 250;
		else speed = 500;
		
		if (taskn > 0) {
			task temp = pop_task();
			if (temp.id == 1) {
				// Main update
				seconds = time (NULL);
				sprintf(sql, "UPDATE `servers` SET gdi = %d, nod = %d, gdi_point = %d, nod_point = %d, map = '%s', last_update = %d WHERE CONVERT(`prefex` USING utf8) = '%s'", Tally_Team_Size(1), Tally_Team_Size(0), int(Get_Team_Score(1)), int(Get_Team_Score(0)), The_Game()->MapName, int(seconds), prefex);
				mysql_query(db, sql);
			} else if (temp.id == 2) {
				// Player Joined
				int pid = temp.parms5;
				GameObject *player = Get_GameObj(pid);
				if (player) {
					// Add the player into the server player list
					sprintf(sql, "INSERT INTO `%s_players` VALUES (%d,'%s',%d,%d,%d,%d,%d,%d,%d,%d,'%s',%d)", prefex, pid, temp.parms, int(Commands->Get_Max_Health(player)), int(Commands->Get_Max_Shield_Strength(player)), int(Commands->Get_Health(player)), int(Commands->Get_Shield_Strength(player)),int(Commands->Get_Money(player)),int(Get_Score(pid)),Get_Kills(pid),Get_Deaths(pid),Commands->Get_Preset_Name(player),Get_Team(pid));
					mysql_query(db, sql);
					Struct_Player temp_pdb;
					Game::Get_Player(pid, &temp_pdb);
					sprintf(sql, "SELECT * FROM `ladder` WHERE CONVERT(`name` USING utf8) LIKE '%s'", temp_pdb.name.c_str());
					mysql_query(db,sql);
					MYSQL_RES *res = mysql_store_result(db);
					seconds = time (NULL);
					char pname[128], mssg[1024];
					strcpy(pname, Get_Player_Name_By_ID(pid));
					if (mysql_num_rows(res) != 0) {
						MYSQL_ROW row = mysql_fetch_row(res);
						temp_pdb.exp = _atoi64(row[8]); // Exp
						temp_pdb.honor = atoi(row[9]); // Honor level
						if (temp_pdb.honor > 150) {
							sprintf(mssg, "This guy must play 24/7 because they are AMAZING at level %d honor!", pname, temp_pdb.honor);
						} else if (temp_pdb.honor > 100) {
							sprintf(mssg, "A true veteran, %s, has arived! And at level %d honor, who wants to challange him?", pname, temp_pdb.honor);
						} else if (temp_pdb.honor > 80) {
							sprintf(mssg, "Welcome back %s the troops are waiting for your command! They are all amazed with your level %d honor!", pname, temp_pdb.honor);
						} else if (temp_pdb.honor > 50) {
							sprintf(mssg, "%s, you are needed right away, your %d honor will come in handy!", pname, temp_pdb.honor);
						} else if (temp_pdb.honor > 30) {
							sprintf(mssg, "Welcome back %s, you are our hero. Please guide us with your level %d honor!", pname, temp_pdb.honor);
						} else {
							sprintf(mssg, "It's nice to see you again %s. [level %d honor]", pname, temp_pdb.honor);
						}
					} else {
						temp_pdb.exp = 0; // Exp
						temp_pdb.honor = 1; // Honor level
						sprintf(mssg, "Welcome %s, the newest addition to the XpHaZe family!", pname);
					}
					mysql_free_result(res);
					Game::Set_Player(pid, temp_pdb);
					XpzCmds::msg(0,"Null",mssg);

					bool banned = false;
					// Check for bans
					sprintf(sql, "SELECT * FROM `bans` WHERE CONVERT(`name` USING utf8) LIKE '%s'", temp_pdb.name.c_str());
					mysql_query(db,sql);
					res = mysql_store_result(db);
					if (mysql_num_rows(res) != 0) {
						banned = true;
						MYSQL_ROW row2 = mysql_fetch_row(res);
						/*char tmp7[1024];
						sprintf(tmp7, "DBG Msg: time: %d(%s), current: %d, difference: %d", atoi(row2[4]), row2[4], (int)seconds, (seconds - atoi(row2[4])));
						Irc::Send_Chan2(0,tmp7);*/
						if (atoi(row2[4]) < int(seconds) && atoi(row2[4]) != 0) {
							// Player has sat out their ban, unban them
							XpzCmds::unban(2,"XpzGuard",temp_pdb.name.c_str());
						} else {
							// player is banned, kick then
							std::string msg = "";
							char tmp[1024];
							if (atoi(row2[4]) == 0) {
								sprintf(tmp, "You are banned forever. Goodbye.");
								XpzCmds::ppage(1,pid,tmp);
								msg = "Forever";
							} else {
								int second = atoi(row2[4]), minute = 0, hour = 0;
								second = second - int(seconds);
								while (second >= 60) {
									second -= 60;
									minute++;
								}
								while (minute >= 60) {
									minute -= 60;
									hour++;
								}
								char tmp[512];
								if (hour > 0) {
									sprintf(tmp, "%d hours", hour);
									msg = tmp;
								}
								if (minute > 0) {
									sprintf(tmp, "%d minutes", minute);
									if (hour > 0) {
										msg += ", ";
										msg += tmp;
									} else {
										msg = tmp;
									}
								}
								if (second > 0) {
									sprintf(tmp, "%d seconds", second);
									if (minute > 0) {
										msg += ", ";
										msg += tmp;
									} else {
										msg = tmp;
									}
								}
								sprintf(tmp, "You are banned for another %s.", msg.c_str());
								XpzCmds::ppage(1,pid,tmp);
							}
							sprintf(tmp, "Previously banned. (Duration: %s)", msg.c_str());
							XpzCmds::kick("XpzGuard", tmp, 0, pid);
						}
					}
					mysql_free_result(res);

					if (banned == false) {
						// Check banned IP only if name match wasn't found
						sprintf(sql, "SELECT * FROM `bans` WHERE ip = '%s'", Get_IP_Address(pid));
						mysql_query(db,sql);
						res = mysql_store_result(db);
						if (mysql_num_rows(res) != 0) {
							MYSQL_ROW row2 = mysql_fetch_row(res);
							char tmp7[1024];
							sprintf(tmp7, "DBG Msg: time: %d(%s), current: %d, difference: %d", atoi(row2[4]), row2[4], (int)seconds, (seconds - atoi(row2[4])));
							Irc::Send_Chan2(0,tmp7);
							if (atoi(row2[4]) < int(seconds) && atoi(row2[4]) != 0) {
								// Player has sat out their ban, unban them
								XpzCmds::unban(2,"XpzGuard",Get_IP_Address(pid));
							} else {
								// player is banned, kick then
								std::string msg = "";
								char tmp[1024];
								if (atoi(row2[4]) == 0) {
									sprintf(tmp, "You are banned forever. Goodbye.");
									XpzCmds::ppage(1,pid,tmp);
									msg = "Forever";
								} else {
									int second = atoi(row2[4]), minute = 0, hour = 0;
									second = second - int(seconds);
									while (second >= 60) {
										second -= 60;
										minute++;
									}
									while (minute >= 60) {
										minute -= 60;
										hour++;
									}
									char tmp[512];
									if (hour > 0) {
										sprintf(tmp, "%d hours", hour);
										msg = tmp;
									}
									if (minute > 0) {
										sprintf(tmp, "%d minutes", minute);
										if (hour > 0) {
											msg += ", ";
											msg += tmp;
										} else {
											msg = tmp;
										}
									}
									if (second > 0) {
										sprintf(tmp, "%d seconds", second);
										if (minute > 0) {
											msg += ", ";
											msg += tmp;
										} else {
											msg = tmp;
										}
									}
									sprintf(tmp, "You are banned for another %s.", msg.c_str());
									XpzCmds::ppage(1,pid,tmp);
								}
								sprintf(tmp, "Previously banned (%s). (Duration: %s)", msg.c_str(), row2[0]);
								XpzCmds::kick("XpzGuard", tmp, 0, pid);
							}
						}
						mysql_free_result(res);
					}


					// Check for mod status
					sprintf(sql, "SELECT * FROM `mods` WHERE CONVERT(`user` USING utf8) LIKE '%s'", temp_pdb.name.c_str());
					mysql_query(db,sql);
					res = mysql_store_result(db);
					if (mysql_num_rows(res) != 0) {
						MYSQL_ROW row2 = mysql_fetch_row(res);

						if (force_idc == true) {
							// nono, i didn't spell idc wrong :S just that idc is a used keyword
							char icd[128];
							sprintf(icd, "IDC_%s",row2[3]); // Sets up the password
							Commands->Attach_Script(Get_GameObj(pid),"Xpz_Login",icd);
						} else T_MySQL->add_task(task(12,NULL,NULL,NULL,0,pid));
					}
					mysql_free_result(res);
				}
			} else if (temp.id == 3) {
				// Player Left
				sprintf(sql, "SELECT * FROM `ladder` WHERE CONVERT(`name` USING utf8) LIKE '%s'", temp.parms);
				mysql_query(db,sql);
				MYSQL_RES *res;
				res = mysql_store_result(db);
				Struct_Player temp_pdb;
				Game::Get_Player(temp.parms5, &temp_pdb);
				Struct_Honor temp_hdb = Game::Get_Honor(temp_pdb.name);
				seconds = time (NULL);
				__int64 games = seconds - temp_pdb.time_joined;
				if (mysql_num_rows(res) != 0) {
					// Already in ladder, just update
					MYSQL_ROW row = mysql_fetch_row(res);
					games = games + _atoi64(row[5]);

					int death = (atoi(row[3])+temp_pdb.deaths);
					int kill = (atoi(row[2])+temp_pdb.kills);
					__int64 score1 = (_atoi64(row[1])+temp_pdb.score);
					float kd;
					if (death == 0) kd = (float)kill;
					else kd = (float)(kill / death);
					__int64 exp = temp_pdb.exp + _atoi64(row[8]);
					sprintf(sql, "UPDATE `ladder` SET score = %I64d, kills = %d, deaths = %d, kd = %f, snipe_honor = %d, tank_honor = %d, exp = %I64d, honor = %d, games = %I64d WHERE CONVERT(`name` USING utf8) LIKE '%s'", score1, kill, death, kd, temp_hdb.snipe_honor, temp_hdb.vkill_honor, exp, temp_pdb.honor, games, temp_pdb.name.c_str());
					mysql_query(db, sql);
				} else {
					// Is not in ladder, add new
					int death = temp_pdb.deaths;
					if (death == 0) death = 1;
					sprintf(sql, "INSERT INTO `ladder` VALUES ('%s', %I64d, %d, %d, %f, %I64d, %d, %d, %I64d, %d)", temp_pdb.name.c_str(), temp_pdb.score, temp_pdb.kills, temp_pdb.deaths, (temp_pdb.kills / death), games, temp_hdb.snipe_honor, temp_hdb.vkill_honor, temp_pdb.exp, temp_pdb.honor);
					mysql_query(db, sql);
				}
				mysql_free_result(res);
				Irc::Send_Chan2(1,sql,true);
				sprintf(sql, "DELETE FROM `%s_players` WHERE id = %d", prefex, temp.parms5);
				mysql_query(db, sql);
				Game::Set_Player(temp.parms5, Struct_Player("",0,0));
			} else if (temp.id == 4) {
				// Player Update
				int pid = temp.parms5;
				GameObject *player = Get_GameObj(pid);
				if (player) {
					sprintf(sql, "UPDATE `%s_players` SET max_hp = %d, max_sp = %d, now_hp = %d, now_sp = %d, credit = %d, score = %d, kills = %d, deaths = %d, preset = '%s', side = %d WHERE id = %d", prefex, int(Commands->Get_Max_Health(player)), int(Commands->Get_Max_Shield_Strength(player)), int(Commands->Get_Health(player)), int(Commands->Get_Shield_Strength(player)),int(Commands->Get_Money(player)),int(Get_Score(pid)),Get_Kills(pid),Get_Deaths(pid),Commands->Get_Preset_Name(player),Get_Team(pid),pid);
					mysql_query(db, sql);
				}
			} else if (temp.id == 5) {
				// New Building (Param5-game, base ID)
				GameObject *obj = Commands->Find_Object(temp.parms5);
				if (obj) {
					sprintf(sql, "INSERT INTO `%s_building` VALUES (%d, '%s', %d, %d, %d, %d, %d)", prefex, temp.parms5, Commands->Get_Preset_Name(obj), Get_Object_Type(obj), int(Commands->Get_Max_Health(obj)), int(Commands->Get_Max_Shield_Strength(obj)), int(Commands->Get_Health(obj)), int(Commands->Get_Shield_Strength(obj)));
					mysql_query(db, sql);
				}
			} else if (temp.id == 6) {
				// Building Update (Param5-game, base ID)
				GameObject *obj = Commands->Find_Object(temp.parms5);
				if (obj) {
					sprintf(sql, "UPDATE `%s_building` SET now_hp = %d, now_sp = %d WHERE id = %d", prefex, int(Commands->Get_Health(obj)), int(Commands->Get_Shield_Strength(obj)), temp.parms5);
					mysql_query(db, sql);
				}
			} else if (temp.id == 7) {
				// New Map, Buildings Clear
				sprintf(sql, "DELETE FROM `%s_building`");
				mysql_query(db, sql);
			} else if (temp.id == 8 || temp.id == 11) {
				// Kick
				// param4 = type
				// types:
				// 1 - Qkick
				// 2 - kick / tban
				// 3 - ban
				// 4 - ban ip
				// 5 - kick ip / tban ip
				// param = name/ip
				// param2 = reason
				// param3 = kicker
				// param5 = time
				int type = 0;
				
				if (temp.parms4 == 1) type = 2;
				else if (temp.parms4 == 2) type = 3;
				else if (temp.parms4 == 3) type = 4;
				else if (temp.parms4 == 4) type = 4;
				else if (temp.parms4 == 5) type = 3;

				std::string buffer = temp.parms2, tmp;
				std::vector <std::string> words;
				int counter = 0;
				while (buffer.find(" ", 0) != std::string::npos) {
					size_t pos = buffer.find(" ", 0);
					tmp = buffer.substr(0, pos);
					buffer.erase(0, pos + 1);
					words.push_back(tmp);
					counter++;
					if (counter > 0) break;
				}
				words.push_back(buffer);

				// words[0] is IP
				// words[1] is Reason

				seconds = time (NULL);
				sprintf(sql, "INSERT INTO `log` VALUES ('%s', %d, '%s', '%s', %d, '%s', '%s')", temp.parms3, type, temp.parms4 != 4 && temp.parms4 != 5 ? temp.parms : words[0].c_str(), words[1].c_str(), seconds+temp.parms5, words[0].c_str(), "Serial_Hash");
				mysql_query(db, sql);
				sprintf(sql, "INSERT INTO `bans` VALUES ('%s', %d, '%s', '%s', %d)", temp.parms4 != 4 && temp.parms4 != 5 ? temp.parms : words[0].c_str(), type, words[0].c_str(), "Serial_Hash", temp.parms4 == 3 || temp.parms4 == 4 ? 0 : seconds+temp.parms5);
				mysql_query(db, sql);
			} else if (temp.id == 9) {
				// Unban
				// param4 = type
				// types:
				// 1 - ip
				// 2 - name
				// param = name
				// param2 = ip
				// param3 = unbanner
				seconds = time (NULL);
				if ((int)temp.parms4 == 2) {
					sprintf(sql, "DELETE FROM `bans` WHERE name LIKE '%s'", temp.parms);
					sprintf(sql2, "INSERT INTO `log` VALUES ('%s', 5, '%s', 'Unbanned', %d, '', 'Serial_Hash')", temp.parms3, temp.parms, seconds);
				} else {
					sprintf(sql, "DELETE FROM `bans` WHERE ip = '%s'", temp.parms2);
					sprintf(sql2, "INSERT INTO `log` VALUES ('%s', 5, '', 'Unbanned', %d, '%s', 'Serial_Hash')", temp.parms3, seconds, temp.parms2);
				}
				mysql_query(db, sql);
				mysql_query(db, sql2);
			} else if (temp.id == 10) {
				// Raw query
				mysql_query(db, temp.parms);
			} else if (temp.id == 12) {
				// After authentication, log em in ;P
				int pid = temp.parms5;
				GameObject *player = Get_GameObj(pid);
				if (player) {
					Struct_Player temp_pdb;
					Game::Get_Player(pid, &temp_pdb);
					sprintf(sql, "SELECT * FROM `mods` WHERE CONVERT(`user` USING utf8) LIKE '%s'", temp_pdb.name.c_str());
					mysql_query(db,sql);
					MYSQL_RES *res;
					res = mysql_store_result(db);
					if (mysql_num_rows(res) != 0) {
						MYSQL_ROW row2 = mysql_fetch_row(res);
						if (atoi(row2[1]) != 0) {
							Game::Get_Player(pid, &temp_pdb);
							temp_pdb.mod = atoi(row2[1]);
							temp_pdb.mod_flags = row2[2];
							Game::Set_Player(pid, temp_pdb);
							char announce[1024], ranks[128];
							if (temp_pdb.mod == 1) strcpy(ranks, "VIP");
							else if (temp_pdb.mod == 2) strcpy(ranks, "Half-Moderator");
							else if (temp_pdb.mod == 3) strcpy(ranks, "Moderator");
							else if (temp_pdb.mod == 4) strcpy(ranks, "Administrator");
							else if (temp_pdb.mod == 5) strcpy(ranks, "Owner");
							sprintf(announce, "%s has logged in as a game %s.", temp_pdb.name.c_str(), ranks);
							XpzCmds::msg(0,"NULL",announce);
						}
					}
					Game::Set_Player(pid, temp_pdb);
					mysql_free_result(res);
				}
			} else if (temp.id == 13) {
				if (temp.parms5 == 1) sprintf(sql, "INSERT INTO `defense` VALUES ('Nod_Turret_MP', 2000, 0, %s, %s, %s, 0, 0, '%s')", temp.parms, temp.parms2, temp.parms3, The_Game()->MapName);
				if (temp.parms5 == 2) sprintf(sql, "INSERT INTO `crates` VALUES ('%s', %s, %s, %s)", The_Game()->MapName, temp.parms, temp.parms2, temp.parms3);
				mysql_query(db,sql);
			} else if (temp.id == 14) {
				// Get the base defence information
				// parms - map
				sprintf(sql, "SELECT * FROM `defense` WHERE CONVERT(`map` USING utf8) LIKE '%s'", temp.parms);
				mysql_query(db,sql);
				MYSQL_RES *res = mysql_store_result(db);
				int rows = (int)mysql_num_rows(res);
				if (rows > 0) {
					if (wait("bd") == true) { // checks Mutex with 0.5 seconds for timeout
						for (int i = 0; i < rows; i++) {
							MYSQL_ROW row = mysql_fetch_row(res);
							// 0 - preset
							// 1 - cost
							// 2 - health
							// 3 - loc_x
							// 4 - loc_y
							// 5 - loc_z
							// 6 - const_time
							// 7 - side
							// 8 - map
							Vector3 loc;
							loc.X = (float)atof(row[3]);
							loc.Y = (float)atof(row[4]);
							loc.Z = (float)atof(row[5]);
							base_defense_list.push_back(Struct_Base_Defense(row[0],atoi(row[7]),atoi(row[1]),loc,false));
						}
						release("bd"); // Releases the base defense Mutex
						if (wait("ms") == true) {
							if (rows > 0) {
								map_setting.bd_num = rows;
								map_setting.bd_loaded = 2;
							} else {
								map_setting.bd_num = 0;
								map_setting.bd_loaded = -1;
							}
							release("ms");
						}
					}
				}
				mysql_free_result(res);
			} else if (temp.id == 15) {
				// Map settings
				sprintf(sql, "SELECT * FROM `maps` WHERE CONVERT(`prefex` USING utf8) LIKE '%s' OR CONVERT(`prefex` USING utf8) LIKE 'all' AND CONVERT(`map` USING utf8) LIKE '%s'", prefex, temp.parms);
				mysql_query(db,sql);
				MYSQL_RES *res = mysql_store_result(db);
				int rows = (int)mysql_num_rows(res);
				if (rows > 0) {
					if (wait("ms", 500) == true) {
						MYSQL_ROW row = mysql_fetch_row(res);
						// 0 - mapname
						// 1 - prefex
						// 2 - crate timer (base)
						// 3 - crate timer variance
						// 4 - base defence chance
						map_setting.bd_active = false;
						map_setting.bd_chance = atoi(row[4]);
						map_setting.bd_num = 0;
						map_setting.crate_num = 0;
						map_setting.crate_pending = false;
						map_setting.crate_time = atoi(row[2]);
						map_setting.crate_var = atoi(row[3]);
						Vector3 vecT;
						vecT.X = 0;
						vecT.Y = 0;
                        vecT.Z = 0;
						map_setting.last_crate = vecT;
						map_setting.loaded = 2;
						release("ms");
					}
				}
				mysql_free_result(res);
			} else if (temp.id == 16) {
				// load crate information
				sprintf(sql, "SELECT * FROM `crates` WHERE CONVERT(`map` USING utf8) LIKE '%s'", temp.parms);
				mysql_query(db,sql);
				MYSQL_RES *res = mysql_store_result(db);
				int rows = (int)mysql_num_rows(res);
				if (rows > 0) {
					if (wait("crate", 500) == true) {
						// 0 - map name
						// 1 - x
						// 2 - y
						// 3 - z
						for (int i = 0; i < rows; i++) {
							MYSQL_ROW row = mysql_fetch_row(res);
							Vector3 temp_vec3;
							temp_vec3.X = (float)atof(row[1]);
							temp_vec3.X = (float)atof(row[2]);
							temp_vec3.X = (float)atof(row[3]);
							crate_list.push_back(temp_vec3);
						}
						release("crate");
					}
				}
				mysql_free_result(res);
				if (wait("ms") == true) {
					if (rows > 0) {
						map_setting.crate_num = rows;
						map_setting.crate_loaded = 2;
					} else {
						map_setting.crate_num = 0;
						map_setting.crate_loaded = -1;
					}
					release("ms");
				}
			}
		}
		sleep(speed);
	}
}

bool MySQL_Thread::connect(MYSQL *db, const char *ip, const char *user, const char *pass, const char *db_main, int port) {
	int i = 0;
	while (mysql_real_connect(db,ip,user,pass,db_main,port,NULL,0) == NULL && i < 10) {
		i++;
	}
	if (i == 10) return false;
	else return true;
}

void MySQL_Thread::disconnect(MYSQL *db) {
	mysql_close(db);
}

void IRC_Thread::run() {
	speed = 200; // Default refresh speed
	Game::ConsoleU("IRC Thread is Starting\n");
	char tmp_ip[128];
	ini_main->Get_String("irc","ip","127.0.0.1",tmp_ip,128);
	Socket IrcSock(tmp_ip, ini_main->Get_Int("irc","port",6667));
	IrcSock.Connect();
	connect(IrcSock.Get_Socket());
	int looper = 0;
	bool output = ini_main->Get_Bool("irc","output",false);
	
	bool running = true;
	while (running == true) {
		int taskn = get_tasks();

		// Speed throttle
		/*if (taskn > 100) speed = 50;
		else if (taskn > 50) speed = 100;
		else if (taskn > 20) speed = 150;
		else speed = 200;*/

		if (taskn > 0 && IrcSock.IsConnected() == true) {
			char temp2[2048];
			task temp = pop_task();
			/*
			1 - Raw send
			2 - Channel # send
			3 - Notice
			4 - Admin/Public channel send
			5 - Public channel send
			6 - Admin channel send
			*/
			if (temp.id == 1) {
				send(IrcSock.Get_Socket(), temp.parms, strlen(temp.parms), 0);
			} else if (temp.id == 2) {
				sprintf(temp2, "PRIVMSG %s :%s\n", temp.parms, temp.parms2);
				send(IrcSock.Get_Socket(), temp2, strlen(temp2), 0);
			} else if (temp.id == 3) {
				sprintf(temp2, "NOTICE %s :%s\n", temp.parms, temp.parms2);
				send(IrcSock.Get_Socket(), temp2, strlen(temp2), 0);
			} else if (temp.id == 4) {
				sprintf(temp2, "PRIVMSG %s :%s\n", this->chan, temp.parms);
				send(IrcSock.Get_Socket(), temp2, strlen(temp2), 0);
				sprintf(temp2, "PRIVMSG %s :%s\n", this->chan2, temp.parms);
				send(IrcSock.Get_Socket(), temp2, strlen(temp2), 0);
			} else if (temp.id == 5) {
				sprintf(temp2, "PRIVMSG %s :%s\n", this->chan, temp.parms);
				send(IrcSock.Get_Socket(), temp2, strlen(temp2), 0);
			} else if (temp.id == 6) {
				sprintf(temp2, "PRIVMSG %s :%s\n", this->chan2, temp.parms);
				send(IrcSock.Get_Socket(), temp2, strlen(temp2), 0);
			}
		}

		char read[4098];
		if (IrcSock.Get_Line(read) == true) {
			if(strncmp(read,"PING ",5)==0) {
				char msg[1024];
				strcpy(msg,read);
				msg[1]='O';
				Irc::Send_Raw(msg);
			} else {
				std::string buffer = read, temp;
				std::vector <std::string> words;
				int counter = 0;
				while (buffer.find(" ", 0) != std::string::npos) {
					size_t pos = buffer.find(" ", 0);
					temp = buffer.substr(0, pos);
					buffer.erase(0, pos + 1);
					words.push_back(temp);
					counter++;
					if (counter > 2) break;
				}
				words.push_back(buffer);
				words[0].erase(0,1); // Message starts off with :, so to remove

				if (stricmp(words[1].c_str(), "PRIVMSG") == 0) {
					words[0].erase(words[0].find("!", 0), words[0].find(" ", 0));
					char tmp0[2048];
					words[3].erase(0,1); // Message starts off with :, so to remove
					strcpy(tmp0, words[3].c_str());
					if (tmp0[0] == '!') T_Handler->add_task(task(3, words[2].c_str(), words[0].c_str(), words[3].c_str())); // 2-channel, 3-nick, 4-message
					if (output == true) {
						char read2[4048];
						sprintf(read2,"   [IRC] (%s)%s: %s\n",words[2].c_str(),words[0].c_str(),words[3].c_str());
						Game::ConsoleU(read2);
					}
				} else if (stricmp(words[1].c_str(), "MODE") == 0) {
					char temp_char[128], temp_char2[128];
					if (stricmp(words[2].c_str(),this->chan) == 0) strcpy(temp_char, this->chan);
					else if (stricmp(words[2].c_str(),this->chan2) == 0) strcpy(temp_char, this->chan2);
					sprintf(temp_char2,"NAMES %s\n", temp_char);
					Irc::Send_Raw(temp_char2);
					/*bool add = false;
					int num_flag = 0;
					char flags[32];
					std::vector <std::string> names, words2;
					std::string buffer2 = words[3], temp2;
					char temp_char[512];
					int counter2 = 0;
					while (buffer2.find(" ", 0) != std::string::npos) {
						size_t pos2 = buffer2.find(" ", 0);
						temp2 = buffer2.substr(0, pos2);
						buffer2.erase(0, pos2 + 1);
						words2.push_back(temp2);
						counter2++;
						if (counter2 == 1) {
							add = temp2[0] == '+' ? true : false;
							temp2.erase(0,1);
							while (strlen(temp2.c_str()) != 0) {
								// Adds the letter sequentially
								flags[num_flag] = temp2[0];
								num_flag++;
								temp2.erase(0,1);
							}
						}
						if (counter2 > num_flag) break;
					}
					words2.push_back(buffer2);
					int dchan = -1;
					if (stricmp(words[2].c_str(),this->chan) == 0) dchan = 0;
					else if (stricmp(words[2].c_str(),this->chan2) == 0) dchan = 1;
					if (dchan != -1) {
						vector<Irc_Rank> temp1;
						wait("chanrank");
						if (dchan == 0) temp1 = chan_ranks;
						if (dchan == 1) temp1 = chan_ranks2;
						release("chanrank");
						int rank1 = 0;
						for (int i = 1; i < num_flag; i++) {
							// Do this for each person
							for(int ii=0; ii < temp1.size(); ii++) {
								// Look though the channel list for the name
								if (stricmp(temp1[ii].name.c_str(), words2[i+1].c_str()) == 0) {
									// Name found, determine rank
									if (add == true) {
										char p = flags[ii];
										if (p == 'v' || p == 'V') rank1 = 1;
										else if (p == 'h' || p == 'H') rank1 = 2;
										else if (p == 'o' || p == 'O') rank1 = 3;
										else if (p == 'a' || p == 'A') rank1 = 4;
										else if (p == 'q' || p == 'Q') rank1 = 5;
									} else rank1 = 0;
									temp1[ii].rank = rank1;
									sprintf(temp_char, "  [IRC-Event] %s has been promoted to rank: %d\n", words2[i+1].c_str(), rank1);
									Game::ConsoleU(temp_char);
									break;
								}
							}
						}
						wait("chanrank");
						if (dchan == 0) chan_ranks = temp1;
						if (dchan == 1) chan_ranks2 = temp1;
						release("chanrank");
					}*/
				} else if (stricmp(words[1].c_str(), "JOIN") == 0) {
					words[0].erase(words[0].find("!", 0), words[0].find(" ", 0));
					words[2].erase(0,1);
					char temp_char[512];
					sprintf(temp_char, "  [IRC-Event] %s has joined %s\n", words[0].c_str(), words[2].c_str());
					Game::ConsoleU(temp_char);
					Irc_Rank temp1;
					temp1.name = words[0];
					temp1.rank = 0;
					int dchan = -1;
					if (stricmp(words[2].c_str(),this->chan) == 0) dchan = 0;
					else if (stricmp(words[2].c_str(),this->chan2) == 0) dchan = 1;
					if (dchan != -1) {
						wait("chanrank");
						if (dchan == 0) chan_ranks.push_back(temp1);
						if (dchan == 1) chan_ranks2.push_back(temp1);
						release("chanrank");
					}
				} else if (stricmp(words[1].c_str(), "PART") == 0) {
					words[0].erase(words[0].find("!", 0), words[0].find(" ", 0));
					int dchan = 0;
					if (stricmp(words[2].c_str(),this->chan) == 0) dchan = 0;
					else if (stricmp(words[2].c_str(),this->chan2) == 0) dchan = 1;
					char temp_char[512];
					sprintf(temp_char, "  [IRC-Event] %s has parted from %s\n", words[0].c_str(), words[2].c_str());
					Game::ConsoleU(temp_char);
					vector<Irc_Rank> temp1;
					wait("chanrank");
					if (dchan == 0) temp1 = chan_ranks;
					if (dchan == 1) temp1 = chan_ranks2;
					release("chanrank");
					for(unsigned int ii=0; ii < temp1.size(); ii++) {
						if (stricmp(temp1[ii].name.c_str(), words[0].c_str()) == 0) {
							temp1.erase(temp1.begin()+ii-1);
							break;
						}
					}
					wait("chanrank");
					if (dchan == 0) chan_ranks = temp1;
					if (dchan == 1) chan_ranks2 = temp1;
					release("chanrank");
				} else if (stricmp(words[1].c_str(), "QUIT") == 0) {
					words[0].erase(words[0].find("!", 0), words[0].find(" ", 0));
					char temp_char[512];
					sprintf(temp_char, "  [IRC-Event] %s has quit IRC\n", words[0].c_str());
					Game::ConsoleU(temp_char);
					wait("chanrank");
					vector<Irc_Rank> temp1;
					for (int b=0; b!=2; b++) {
						if (b == 0) temp1 = chan_ranks;
						if (b == 1) temp1 = chan_ranks2;
						for(unsigned int ii=0; ii < temp1.size(); ii++) {
							if (stricmp(temp1[ii].name.c_str(), words[0].c_str()) == 0) {
								temp1.erase(temp1.begin()+ii-1);
								break;
							}
						}
					}
					release("chanrank");
				} else if (stricmp(words[1].c_str(), "353") == 0) {
					std::string buffer2 = words[3], temp2;
					std::vector <std::string> words2;
					int counter2 = 0;
					while (buffer2.find(" ", 0) != std::string::npos) {
						size_t pos2 = buffer2.find(" ", 0);
						temp2 = buffer2.substr(0, pos2);
						buffer2.erase(0, pos2 + 1);
						words2.push_back(temp2);
						counter2++;
						if (counter2 > 100) break;
					}
					int dchan = 0;
					words2.push_back(buffer2);
					if (stricmp(words2[1].c_str(),this->chan) == 0) dchan = 1;
					else if (stricmp(words2[1].c_str(),this->chan2) == 0) dchan = 2;

					if (dchan == 1 || dchan == 2) {
						wait("chanrank");
						if (dchan == 1) chan_ranks.empty();
						else if (dchan == 2) chan_ranks2.empty();
						words2[2].erase(0,1);
						char tmp[128];
						for (int try3 = counter2 - 1; try3 > 1; try3--) {
							strcpy(tmp, words2[try3].c_str());
							Irc_Rank r_temp;
							r_temp.rank = 0;
							if (tmp[0] == '+') r_temp.rank = 1;
							else if (tmp[0] == '%') r_temp.rank = 2;
							else if (tmp[0] == '@') r_temp.rank = 3;
							else if (tmp[0] == '&') r_temp.rank = 4;
							else if (tmp[0] == '~') r_temp.rank = 5;
							if (r_temp.rank != 0) words2[try3].erase(0,1);
							r_temp.name = words2[try3];
							if (dchan == 1) chan_ranks.push_back(r_temp);
							else if (dchan == 2) chan_ranks2.push_back(r_temp);
						}
						release("chanrank");
					}
				}
			}
		}

		if (looper == 100) {
			looper = 0;
			if (IrcSock.HasConnectionDropped() == true) {
				IrcSock.DisconnectSock();
				IrcSock.Set1(tmp_ip, ini_main->Get_Int("irc","port",6667));
				IrcSock.Connect(100);
				connect(IrcSock.Get_Socket());
			}
		} else {
			looper++;
		}

		sleep(speed);
	}
}

void IRC_Thread::connect(SOCKET sock) {
	char temp[1024], ircmsg[2048];
	ini_main->Get_String("irc","nick",0,temp,1024);
	sprintf(ircmsg,"NICK %s\n",temp);
	Irc::Send_Raw(ircmsg);
	sprintf(ircmsg,"USER %s \"gmail.com\" \"127.0.0.1\" :%s\n", temp, temp);
	Irc::Send_Raw(ircmsg);
	ini_main->Get_String("irc","auth",0,temp,1024);
	if (temp != 0) {
		sprintf(ircmsg,"%s\n", temp);
		Irc::Send_Raw(ircmsg);
	}
	ini_main->Get_String("irc","auth2",0,temp,1024);
	if (temp != 0) {
		sprintf(ircmsg,"%s\n", temp);
		Irc::Send_Raw(ircmsg);
	}
	ini_main->Get_String("irc","part",0,temp,1024);
	if (temp != 0) {
		sprintf(ircmsg,"PART %s\n", temp);
		Irc::Send_Raw(ircmsg);
	}
	ini_main->Get_String("irc","chan",0,temp,1024);
	strcpy(this->chan,temp);
	ini_main->Get_String("irc","chan2",0,temp,1024);
	strcpy(this->chan2,temp);
	sprintf(ircmsg,"JOIN %s\n", this->chan);
	Irc::Send_Raw(ircmsg);
	sprintf(ircmsg,"JOIN %s\n", this->chan2);
	Irc::Send_Raw(ircmsg);
	sprintf(ircmsg,"PRIVMSG %s :9XpzElite Reporting For Duty! v%s build%s [7Public Channel]\n", this->chan, XPZ_VER, XPZ_BUILD);
	Irc::Send_Raw(ircmsg);
	sprintf(ircmsg,"PRIVMSG %s :9XpzElite Reporting For Duty! v%s build%s [4Admin Channel]\n", this->chan2, XPZ_VER, XPZ_BUILD);
	Irc::Send_Raw(ircmsg);

	Game::ConsoleU("IRC Thread has connected with server\n");
}

void Renguard_Thread::run() {
	speed = 250; // Default refresh speed
	Game::ConsoleU("Renguard Thread is Starting\n");
	Struct_RG_Server master1, master2, master3;
	bool pure = ini_main->Get_Bool("rg","pure",false);
	char tmp[2048], read[4096];
	std::string stmp;
	int connected = 0;
	int port = ini_main->Get_Int("rg","port",6382);
	
	ini_main->Get_String("rg","ip1","81.92.166.90",tmp,2048);
	master1 = Struct_RG_Server(tmp,port);

	ini_main->Get_String("rg","ip2","67.19.143.2",tmp,2048);
	master2 = Struct_RG_Server(tmp,port);

	ini_main->Get_String("rg","ip3","70.84.132.90",tmp,2048);
	master3 = Struct_RG_Server(tmp,port);
	
	Socket RGSock[3];
	RGSock[1].Set_Conn(master1.ip.c_str(),master1.port);
	RGSock[2].Set_Conn(master2.ip.c_str(),master2.port);
	RGSock[3].Set_Conn(master3.ip.c_str(),master3.port);
	SOCKET TheSock;

	bool running = true;
	while (connected == 0) {
		if (RGSock[1].Connect(1) == true) {
			connected = 1;
		} else if (RGSock[2].Connect(1) == true) {
			connected = 2;
		} else if (RGSock[3].Connect(1) == true) {
			connected = 3;
		}
		sleep(500);
	}
	TheSock = RGSock[connected].Get_Socket();
	Game::ConsoleU("Renguard Master Server connection established.\n");

	sprintf(tmp, "123456789\n");
	send(TheSock, tmp, strlen(tmp), 0);


	sprintf(tmp, "300 XpzElite/%s", XPZ_VER);
	stmp = RG::encode64_2(tmp);
	XpzBase::send2(TheSock, stmp.c_str());
	sprintf(tmp, "310 %s", WideCharToChar(The_Game()->Get_Game_Name().m_Buffer));
	stmp = RG::encode64_2(tmp);
	XpzBase::send2(TheSock, stmp.c_str());
	sprintf(tmp, "340");
	stmp = RG::encode64_2(tmp);
	XpzBase::send2(TheSock, stmp.c_str());
	sprintf(tmp, "311 %d", ini_main->Get_Int("rg","motd",0));
	stmp = RG::encode64_2(tmp);
	XpzBase::send2(TheSock, stmp.c_str());
	this->add_task(task(4)); // Tell server current map

	if (pure == true) {
		sprintf(tmp, "313");
		stmp = RG::encode64_2(tmp);
		XpzBase::send2(TheSock, stmp.c_str());
	}

	int i = 0;
	while (The_Game()->MapList[i]) {
		sprintf(tmp, "830 %s", The_Game()->MapList);
		stmp = RG::encode64_2(tmp);
		XpzBase::send2(TheSock, stmp.c_str());
		i++;
		if (i > 100) break;
	}

	while (running == true) {
		int taskn = get_tasks();
		
		// Speed throttle
		if (taskn > 100) speed = 50;
		else if (taskn > 50) speed = 100;
		else if (taskn > 20) speed = 150;
		else speed = 250;
		
		if (taskn > 0) {
			task temp = pop_task();
			if (temp.id == 1) {
				// Send RG
				sprintf(tmp, "%s", temp.parms);
				stmp = RG::encode64_2(tmp);
				XpzBase::send2(TheSock, stmp.c_str());
			} else if (temp.id == 2) {
				// New Player
				if (Is_Playing(temp.parms5) == true) {
					sprintf(tmp, "370 %s %s", Get_IP_Address(temp.parms5), Get_Player_Name_By_ID(temp.parms5));
					stmp = RG::encode64_2(tmp);
					XpzBase::send2(TheSock, stmp.c_str());
				}
			} else if (temp.id == 3) {
				// Player Leave (parms - session id)
				Struct_Player ptmp;
				Game::Get_Player(temp.parms5, &ptmp);
				if (ptmp.rg == true) {
					sprintf(tmp, "322 %s", temp.parms);
					stmp = RG::encode64_2(tmp);
					XpzBase::send2(TheSock, stmp.c_str());
				}
			} else if (temp.id == 4) {
				// New Map
				sprintf(tmp, "320 %s", The_Game()->MapName);
				stmp = RG::encode64_2(tmp);
				XpzBase::send2(TheSock, stmp.c_str());
			} else if (temp.id == 5) {
				// Bind Player
				sprintf(tmp, "320 %s", The_Game()->MapName);
				stmp = RG::encode64_2(tmp);
				XpzBase::send2(TheSock, stmp.c_str());
			}
		}

		if (RGSock[connected].Get_Line(read) == true) {
			std::string buffer = XpzBase::base64_decode(read), temp, buffer2 = "   [RG-Msg]: ";
			buffer2 += buffer;
			Irc::Send_Chan2(1,buffer2.c_str());
			Game::ConsoleU(buffer2.c_str());
			std::vector <std::string> words;
			int counter = 0;
			while (buffer.find(" ", 0) != std::string::npos) {
				size_t pos = buffer.find(" ", 0);
				temp = buffer.substr(0, pos);
				buffer.erase(0, pos + 1);
				words.push_back(temp);
				counter++;
				if (counter > 3) break;
			}
			words.push_back(buffer);
			
			if (strcmp(words[0].c_str(), "280") == 0) {
				// Add user response, yes rg
				// 280 <user ip> <user session id> <user name>
				int id = Get_Player_ID(Get_GameObj_By_Player_Name(words[3].c_str()));
				Struct_Player ptmp;
				Game::Get_Player(id, &ptmp);
				ptmp.rg = true;
				ptmp.rg_session = words[2];
				Game::Set_Player(id, ptmp);
			} else if (strcmp(words[0].c_str(), "281") == 0) {
				// Add user response, no rg
				// 281 <username>
			} else if (strcmp(words[0].c_str(), "271") == 0) {
				// Cheating
			} else if (strcmp(words[0].c_str(), "272") == 0) {
				// Unknown files
			} else if (strcmp(words[0].c_str(), "273") == 0 && pure == true) {
				// Skins
			} else if (strcmp(words[0].c_str(), "410") == 0) {
				// Disconnected
				bool con_est = false;
				while (con_est == false) {
					if (connected == 3) {
						if (RGSock[1].Connect(2) == true) {
							connected = 1;
							con_est = true;
							break;
						}
					} else if (connected == 2) {
						if (RGSock[3].Connect(2) == true) {
							connected = 3;
							con_est = true;
							break;
						}
					} else if (connected == 1) {
						if (RGSock[2].Connect(2) == true) {
							connected = 2;
							con_est = true;
							break;
						}
					}
					sleep(500);
				}
			}
		}
		sleep(speed);
	}
}

void TeamSpeak_Thread::run() {
	speed = 200; // Default refresh speed
	Game::ConsoleU("TeamSpeak Thread has Started\n");
	Socket TSSock;
	
	bool running = true;
	while (running == true) {
		int taskn = get_tasks();

		// Speed throttle
		if (taskn > 100) speed = 50;
		else if (taskn > 50) speed = 100;
		else if (taskn > 20) speed = 150;
		else speed = 200;
		
		if (taskn > 0) {
			task temp = pop_task();
			if (temp.id == 1) {
			} else if (temp.id == 2) {
			}
		}
		sleep(speed);
	}
}

void TeamSpeak_Thread::connect(SOCKET sock) {
	Game::ConsoleU("TeamSpeak Thread has connected with server\n");
}


void XpzGuard_Thread::run() {
	speed = 200; // Default refresh speed
	Game::ConsoleU("XpzGuard Thread has Started\n");
	
	bool running = true;
	while (running == true) {
		int taskn = get_tasks();

		// Speed throttle
		if (taskn > 100) speed = 50;
		else if (taskn > 50) speed = 100;
		else if (taskn > 20) speed = 150;
		else speed = 200;

		if (taskn > 0) {
			task temp = pop_task();
			if (temp.id == 1) {
			} else if (temp.id == 2) {
			}
		}
		sleep(speed);
	}
}

/* =================================================================================================
ObjectHookClass (When something is created, it defines what to attach)
------------------------------------------------------------------------------------------------- */

class ObjectHookClass {
public:
	void NewObject(GameObject *obj);
	void Start();
	~ObjectHookClass();
	ObjectCreateHookStruct *o;
private:
	int id;
};

void ObjectHookCall (void *data,GameObject *obj) {
	ObjectHookClass *Base = (ObjectHookClass*)data;
	Base->NewObject(obj);
}

void ObjectHookClass::Start() {
	o = new ObjectCreateHookStruct;
	o->hook = ObjectHookCall;
	o->data = (void*)this;
	id = AddObjectCreateHook(o);
}

void ObjectHookClass::NewObject(GameObject *obj) {
	if (XpzElite_Inited != true) {
		XpzElite_Inited = true;
		T_Handler->start();
		if (ini_main->Get_Bool("irc","enable",false) == true) T_IRC->start();
		if (ini_main->Get_Bool("rg","enable",false) == true) T_Renguard->start();
		if (ini_main->Get_Bool("teamspeak","enable",false) == true) T_TeamSpeak->start();
		if (ini_main->Get_Bool("db","enable",false) == true) T_MySQL->start();
		current_map = The_Game()->MapName;
	}

	if (first_obj == true) {
		if (ini_main->Get_Bool("db","enable",false) == true) {
			T_Handler->add_task(task(5));
			T_MySQL->add_task(task(14,current_map.c_str())); // BD info
			//T_MySQL->add_task(task(15,current_map.c_str())); // Map info
			//T_MySQL->add_task(task(16,current_map.c_str())); // Crate info
		}
		first_obj = false;
	}

	if (Is_Soldier(obj) == true) {
		Attach_Script_Once(obj,"XpzElite_Player","");
	} else if (Is_Vehicle(obj) == true) {
		Attach_Script_Once(obj,"XpzElite_Tank","");
	} else if (Is_Beacon(obj) == true) {
        Attach_Script_Once(obj,"XpzElite_Beacon","");
	}
}

ObjectHookClass::~ObjectHookClass()
{
	if (id && RemoveObjectCreateHook) RemoveObjectCreateHook(id);
}

// Definitions
ObjectHookClass *ObjectHook = new ObjectHookClass;

/* =================================================================================================
Initialization (start the hooks and threads), Initialize functions
------------------------------------------------------------------------------------------------- */

void XpzElite_Init() {
	SetPriorityClass(GetCurrentProcess(), ABOVE_NORMAL_PRIORITY_CLASS);
	ini_main = Get_INI(CFG);
	ini_maps = Get_INI(MAP_CFG);
	ini_mods = Get_INI(MOD_CFG);
	char tmp[128], tmp2[256];
	ini_main->Get_String("main","objects","aow",tmp,128);
	sprintf(tmp2, "data/objects.%s", tmp);
	if (file_exists(tmp2) == true) Change_Objects_File(tmp);
	else Change_Objects_File("aow");
	ObjectHook->Start();
	AddPlayerJoinHook(PJoin);
	AddChatHook(Chat);
	AddHostHook(Host);
	AddLoadLevelHook(LoadLevel);
	AddGameOverHook(GameOver);
	AddVersionHook(BHS_Hook);
	force_idc = ini_main->Get_Bool("main", "force_idc", false);
}

void Chat(int id,int type,const wchar_t *Message) {
	if (type != 0 && type != 1) return;
	T_Handler->add_task(task(4, WideCharToChar(Message), NULL, NULL, id, type == 0 ? 2 : 1));
}

void Host(int PlayerID,int type,const char *Message) {
	if (type != 0) return;
	char tmp[1024];
	sprintf(tmp, "14Host: %s", Message);
	Irc::Send_Chan2(0, tmp);
}

void LoadLevel() {
	gameoverd = false;
	Vector3 loc;
	loc.X = 0;
	loc.Y = 0;
	loc.Z = 0;
	desGDI = 0;
	desNod = 0;
	fundGDI = 0;
	fundNod = 0;
	if (!rtc_nod.empty()) rtc_nod.erase(rtc_nod.begin(), rtc_nod.end()); // Empty the request team change list for Nod
	if (!rtc_gdi.empty()) rtc_gdi.erase(rtc_gdi.begin(), rtc_gdi.end()); // Empty the request team change list for GDI
	rtc_enable = ini_main->Get_Bool("main","rtc_allow",true);
	rtc_time = ini_main->Get_Int("main", "rtc_time", 300);
	global = Commands->Create_Object("Invisible_Object", loc);
	Attach_Script_Once(global,"XpzElite_Timer","");
	Attach_Script_Once(global,"XpzElite_Crates","");
	//Attach_Script_Once(global,"XpzElite_Player_Level","");
	if (ini_main->Get_Bool("rg","enable",false) == true) T_Renguard->add_task(task(4));
	if (ini_main->Get_Bool("db","enable",false) == true) T_MySQL->add_task(task(1));
	char msg[1024];
	sprintf(msg, "A new round has commenced on %s.", Game::phrase_map(The_Game()->MapName).c_str());
	Irc::Send_Chan2(0, msg, true);
	current_map = The_Game()->MapName;
	if (ini_main->Get_Bool("db","enable",false) == true) {
		T_MySQL->add_task(task(14,current_map.c_str())); // BD info
		T_MySQL->add_task(task(15,current_map.c_str())); // Map info
		T_MySQL->add_task(task(16,current_map.c_str())); // Crate info
	}
}

void GameOver() {
	/*gameoverd = true;*/
	for (int i = 0; i < 128; i++) {
		bound_vehs[i].tank_id = 0;
	}
	Game::Reset_Honor_All();
	char tmp[128], tmp2[256];
	ini_main->Get_String("main","objects","aow",tmp,128);
	sprintf(tmp2, "data/objects.%s", tmp);
	if (file_exists(tmp2) == true) Change_Objects_File(tmp);
	else Change_Objects_File("aow");
	char msg[1024], WinType[64];

	if (The_Game()->WinType == 3) sprintf(WinType, "Base Destruction");
	else if (The_Game()->WinType == 2) sprintf(WinType, "High score when time limit expired");
	else if (The_Game()->WinType == 4) sprintf(WinType, "Pedestal Beacon");
	else if (The_Game()->WinType == 0) sprintf(WinType, "Server Shutdown");
	else sprintf(WinType, "Unknown");

	if (The_Game()->WinType != 0) {
		sprintf(msg, "The round on %s has ended. The next map is %s.", Game::phrase_map(current_map).c_str(), Game::phrase_map(The_Game()->MapName).c_str());
		Irc::Send_Chan2(0, msg, true);
		sprintf(msg, "%s won due to %s with %d points.", The_Game()->WinnerID == 0 ? "Nod" : "GDI", WinType, Get_Team_Score(The_Game()->WinnerID));
		Irc::Send_Chan2(0, msg, true);
		sprintf(msg, "%s lost with %d points.", The_Game()->WinnerID == 0 ? "GDI" : "Nod", The_Game()->WinnerID == 1 ? Get_Team_Score(0) : Get_Team_Score(1));
		Irc::Send_Chan2(0, msg, true);
		sprintf(msg, "Nod destroyed %d of GDI's buildings, while suffering the loss of %d buildings.", desGDI, desNod);
		Irc::Send_Chan2(0, msg, true);
	} else {
		sprintf(msg, "The round on %s has ended due to %s. The next map is %s.", Game::phrase_map(current_map).c_str(), WinType, Game::phrase_map(The_Game()->MapName).c_str());
		Irc::Send_Chan2(0, msg, true);
	}

	if (restartm == true) {
		XpzCmds::msg(1,"NULL","Server is now restarting... Please rejoin in 2 minutes.");
		Game::ConsoleI("restart");
	}

	first_obj = true;
}

void PJoin(int id, const char *name) {
	// MySQL query for bans goes here
	Game::New_Player(id, name, Get_Bandwidth(id), 0);
	char tmp[512];
	sprintf(tmp, "11Player %s has joined the %s.", name, Get_Team(id) == 0 ? "Brotherhood of Nod" : "Global Defense Initiative");
	Irc::Send_Chan2(0, tmp);
	if (ini_main->Get_Bool("rg","enable",false) == true) T_Renguard->add_task(task(2,NULL,NULL,NULL,0,id));
	if (ini_main->Get_Bool("db","enable",false) == true) T_MySQL->add_task(task(2,name,NULL,NULL,0,id));
}

void Player_Leave(int id, bool new_map) {
	Struct_Player temp;
	Game::Get_Player(id, &temp);
	if (strlen(temp.name.c_str()) == 0) return;
	time_t seconds = time (NULL);
	int second = temp.time_joined, minute = 0, hour = 0;
	second = seconds - second;
	while (second >= 60) {
		second -= 60;
		minute++;
	}
	while (minute >= 60) {
		minute -= 60;
		hour++;
	}
	char tmp[512];
	std::string msg = "";
	if (hour > 0) {
		sprintf(tmp, "%d hours", hour);
		msg = tmp;
	}
	if (minute > 0) {
		sprintf(tmp, "%d minutes", minute);
		if (hour > 0) {
			msg += ", ";
			msg += tmp;
		} else {
			msg = tmp;
		}
	}
	if (second > 0) {
		sprintf(tmp, "%d seconds", second);
		if (minute > 0) {
			msg += ", ";
			msg += tmp;
		} else {
			msg = tmp;
		}
	}
	sprintf(tmp, "11Player %s left the game, after playing for %s!", temp.name.c_str(), msg.c_str());
	Irc::Send_Chan2(0, tmp);
	int rtc0 = Game::within_rtc(temp.name, 0), rtc1 = Game::within_rtc(temp.name, 1);

	if (rtc0 > 0) rtc_nod.erase(rtc_nod.begin() + rtc0 - 1);
	if (rtc1 > 0) rtc_gdi.erase(rtc_gdi.begin() + rtc0 - 1);

	if (new_map == false) {
		GameObject *tank = Commands->Find_Object(Game::Get_Veh_Owner(id));
		if (tank != 0) Commands->Send_Custom_Event(tank, tank, CUSTOM_XPZ_EVENT_UNBIND, id, 0);
	}
	if (ini_main->Get_Bool("rg","enable",false) == true && temp.rg == true) T_Renguard->add_task(task(3,temp.rg_session.c_str(),NULL,NULL,0,0));
	if (ini_main->Get_Bool("db","enable",false) == true) T_MySQL->add_task(task(3,temp.name.c_str(),NULL,NULL,0,0));
	else Game::Set_Player(id, Struct_Player("",0,0));
}

void BHS_Hook(int PlayerID,float ver) {
	Struct_Player temp;
	Game::Get_Player(PlayerID,&temp);
	temp.bhs = ver;
	Game::Set_Player(PlayerID,temp);
}

bool file_exists(const char *file_name) {
	FILE *tmp;
	bool value = false;
	tmp = fopen(file_name,"rb");
	if(tmp != NULL) value = true;
	if(value) fclose(tmp);
	return (value);
}

bool t_restart(Thread *tcurrent) {
	std::string tmp_name = tcurrent->getName();
	HANDLE h = OpenMutex(MUTEX_ALL_ACCESS,FALSE,tmp_name.c_str());
	DWORD d = WaitForSingleObject(h,500);
	bool tmp = false;
	switch(d) {
	case WAIT_ABANDONED:
		break;
	case WAIT_OBJECT_0:
		tcurrent->stop();
		tcurrent->start();
		tmp = true;
	case WAIT_TIMEOUT:
		break;
	}
	ReleaseMutex(h);
	return tmp;
}

void Game::ConsoleU(const char *param) { // The new Console_Input
	T_Handler->add_task(task(1, param));
}

void Game::ConsoleI(const char *param) { // The new Console_Input
	T_Handler->add_task(task(2, param));
}

int Game::Validate_Tank(const char *preset) {
	if (!preset) return 0;
	int valid = 0;

	if (stricmp(preset,"CnC_GDI_APC") == 0) valid = 2;
	else if (stricmp(preset,"Nod_APC") == 0) valid = 2;
	else if (stricmp(preset,"CnC_Nod_APC") == 0) valid = 2;
	else if (stricmp(preset,"GDI_Humm-vee") == 0) valid = 1;
	else if (stricmp(preset,"CnC_GDI_Humm-vee") == 0) valid = 1;
	else if (stricmp(preset,"Nod_Buggy") == 0) valid = 1;
	else if (stricmp(preset,"CnC_Nod_Buggy") == 0) valid = 1;
	else if (stricmp(preset,"CnC_GDI_Mammoth_Tank") == 0) valid = 4;
	else if (stricmp(preset,"CnC_GDI_Medium_Tank") == 0) valid = 3;
	else if (stricmp(preset,"CnC_GDI_MRLS") == 0) valid = 2;
	else if (stricmp(preset,"CnC_GDI_Orca") == 0) valid = 3;
	else if (stricmp(preset,"GDI_Transport") == 0) valid = 2;
	else if (stricmp(preset,"CnC_GDI_Transport") == 0) valid = 2;
	else if (stricmp(preset,"Nod_Transport") == 0) valid = 2;
	else if (stricmp(preset,"CnC_Nod_Transport") == 0) valid = 2;
	else if (stricmp(preset,"CnC_Nod_Apache") == 0) valid = 3;
	else if (stricmp(preset,"CnC_Nod_Flame_Tank") == 0) valid = 3;
	else if (stricmp(preset,"CnC_Nod_Light_Tank") == 0) valid = 3;
	else if (stricmp(preset,"CnC_Nod_Mobile_Artillery") == 0) valid = 2;
	else if (stricmp(preset,"CnC_Nod_Recon_Bike") == 0) valid = 3;
	else if (stricmp(preset,"CnC_Nod_Stealth_Tank") == 0) valid = 4;
	else if (stricmp(preset,"CnC_GDI_Harvester") == 0) valid = 5;
	else if (stricmp(preset,"CnC_Nod_Harvester") == 0) valid = 5;
	else if (stricmp(preset,"Nod_Turret_MP") == 0) valid = 5;
	else if (stricmp(preset,"Nod_Turret_MP_Improved") == 0) valid = 5;

	return valid;
}

int Game::Validate_Soldier(const char *preset) {
	if (!preset) return 0;
	int valid = 0;

	if (stricmp(preset,"CnC_GDI_Engineer_0") == 0) valid = 1;
	else if (stricmp(preset,"CnC_GDI_Engineer_2SF") == 0) valid = 3;
	else if (stricmp(preset,"CnC_GDI_Grenadier_0") == 0) valid = 1;
	else if (stricmp(preset,"CnC_GDI_Grenadier_2SF") == 0) valid = 3;
	else if (stricmp(preset,"CnC_Ignatio_Mobius") == 0) valid = 4;
	else if (stricmp(preset,"CnC_Ignatio_Mobius_ALT2") == 0) valid = 4;
	else if (stricmp(preset,"CnC_GDI_MiniGunner_0") == 0) valid = 1;
	else if (stricmp(preset,"CnC_GDI_MiniGunner_1Off") == 0) valid = 2;
	else if (stricmp(preset,"CnC_GDI_MiniGunner_2SF") == 0) valid = 3;
	else if (stricmp(preset,"CnC_GDI_MiniGunner_3Boss") == 0) valid = 4;
	else if (stricmp(preset,"CnC_GDI_MiniGunner_3Boss_ALT2") == 0) valid = 4;
	else if (stricmp(preset,"CnC_GDI_MiniGunner_3Boss_ALT3") == 0) valid = 4;
	else if (stricmp(preset,"CnC_GDI_MiniGunner_3Boss_ALT4") == 0) valid = 4;
	else if (stricmp(preset,"CnC_GDI_RocketSoldier_0") == 0) valid = 1;
	else if (stricmp(preset,"CnC_GDI_RocketSoldier_1Off") == 0) valid = 2;
	else if (stricmp(preset,"CnC_GDI_RocketSoldier_2SF") == 0) valid = 3;
	else if (stricmp(preset,"CnC_Nod_Engineer_0") == 0) valid = 1;
	else if (stricmp(preset,"CnC_Nod_FlameThrower_0") == 0) valid = 1;
	else if (stricmp(preset,"CnC_Nod_FlameThrower_1Off") == 0) valid = 2;
	else if (stricmp(preset,"CnC_Nod_FlameThrower_2SF") == 0) valid = 3;
	else if (stricmp(preset,"CnC_Nod_FlameThrower_3Boss") == 0) valid = 4;
	else if (stricmp(preset,"CnC_Nod_FlameThrower_3Boss_ALT2") == 0) valid = 4;
	else if (stricmp(preset,"CnC_Nod_Minigunner_0") == 0) valid = 1;
	else if (stricmp(preset,"CnC_Nod_Minigunner_1Off") == 0) valid = 2;
	else if (stricmp(preset,"CnC_Nod_Minigunner_2SF") == 0) valid = 3;
	else if (stricmp(preset,"CnC_Nod_Minigunner_3Boss") == 0) valid = 4;
	else if (stricmp(preset,"CnC_Nod_Minigunner_3Boss_ALT2") == 0) valid = 4;
	else if (stricmp(preset,"CnC_Nod_RocketSoldier_0") == 0) valid = 1;
	else if (stricmp(preset,"CnC_Nod_RocketSoldier_1Off") == 0) valid = 2;
	else if (stricmp(preset,"CnC_Nod_RocketSoldier_2SF") == 0) valid = 3;
	else if (stricmp(preset,"CnC_Nod_RocketSoldier_3Boss") == 0) valid = 4;
	else if (stricmp(preset,"CnC_Nod_RocketSoldier_3Boss_ALT2") == 0) valid = 4;
	else if (stricmp(preset,"CnC_Nod_Technician_0") == 0) valid = 3;
	else if (stricmp(preset,"CnC_Sydney_PowerSuit") == 0) valid = 4;
	else if (stricmp(preset,"CnC_Sydney_PowerSuit_ALT2") == 0) valid = 4;
	else if (stricmp(preset,"CnC_Sydney") == 0) valid = 2;

	return valid;
}

int Game::Get_Price(const char *preset) {
	if (!preset) return 0;
	int price = 0;

	// you'd think theres a better way of doing this, but no -_-"
	if (stricmp(preset,"CnC_GDI_APC") == 0) price = 500;
	else if (stricmp(preset,"Nod_APC") == 0) price = 500;
	else if (stricmp(preset,"CnC_Nod_APC") == 0) price = 500;
	else if (stricmp(preset,"GDI_Humm-vee") == 0) price = 350;
	else if (stricmp(preset,"CnC_GDI_Humm-vee") == 0) price = 350;
	else if (stricmp(preset,"Nod_Buggy") == 0) price = 350;
	else if (stricmp(preset,"CnC_Nod_Buggy") == 0) price = 350;
	else if (stricmp(preset,"CnC_GDI_Mammoth_Tank") == 0) price = 1500;
	else if (stricmp(preset,"CnC_GDI_Medium_Tank") == 0) price = 800;
	else if (stricmp(preset,"CnC_GDI_MRLS") == 0) price = 450;
	else if (stricmp(preset,"CnC_GDI_Orca") == 0) price = 900;
	else if (stricmp(preset,"GDI_Transport") == 0) price = 700;
	else if (stricmp(preset,"CnC_GDI_Transport") == 0) price = 700;
	else if (stricmp(preset,"Nod_Transport") == 0) price = 700;
	else if (stricmp(preset,"CnC_Nod_Transport") == 0) price = 700;
	else if (stricmp(preset,"CnC_Nod_Apache") == 0) price = 900;
	else if (stricmp(preset,"CnC_Nod_Flame_Tank") == 0) price = 800;
	else if (stricmp(preset,"CnC_Nod_Light_Tank") == 0) price = 600;
	else if (stricmp(preset,"CnC_Nod_Mobile_Artillery") == 0) price = 450;
	else if (stricmp(preset,"CnC_Nod_Recon_Bike") == 0) price = 2000;
	else if (stricmp(preset,"CnC_Nod_Stealth_Tank") == 0) price = 900;
	else if (stricmp(preset,"CnC_GDI_Engineer_0") == 0) price = 0;
	else if (stricmp(preset,"CnC_GDI_Engineer_2SF") == 0) price = 350;
	else if (stricmp(preset,"CnC_GDI_Grenadier_0") == 0) price = 0;
	else if (stricmp(preset,"CnC_GDI_Grenadier_2SF") == 0) price = 450;
	else if (stricmp(preset,"CnC_Ignatio_Mobius") == 0) price = 1000;
	else if (stricmp(preset,"CnC_Ignatio_Mobius_ALT2") == 0) price = 1000;
	else if (stricmp(preset,"CnC_GDI_MiniGunner_0") == 0) price = 0;
	else if (stricmp(preset,"CnC_GDI_MiniGunner_1Off") == 0) price = 175;
	else if (stricmp(preset,"CnC_GDI_MiniGunner_2SF") == 0) price = 500;
	else if (stricmp(preset,"CnC_GDI_MiniGunner_3Boss") == 0) price = 1000;
	else if (stricmp(preset,"CnC_GDI_MiniGunner_3Boss_ALT2") == 0) price = 1000;
	else if (stricmp(preset,"CnC_GDI_MiniGunner_3Boss_ALT3") == 0) price = 1000;
	else if (stricmp(preset,"CnC_GDI_MiniGunner_3Boss_ALT4") == 0) price = 1000;
	else if (stricmp(preset,"CnC_GDI_RocketSoldier_0") == 0) price = 0;
	else if (stricmp(preset,"CnC_GDI_RocketSoldier_1Off") == 0) price = 225;
	else if (stricmp(preset,"CnC_GDI_RocketSoldier_2SF") == 0) price = 400;
	else if (stricmp(preset,"CnC_Nod_Engineer_0") == 0) price = 0;
	else if (stricmp(preset,"CnC_Nod_FlameThrower_0") == 0) price = 0;
	else if (stricmp(preset,"CnC_Nod_FlameThrower_1Off") == 0) price = 150;
	else if (stricmp(preset,"CnC_Nod_FlameThrower_2SF") == 0) price = 400;
	else if (stricmp(preset,"CnC_Nod_FlameThrower_3Boss") == 0) price = 1000;
	else if (stricmp(preset,"CnC_Nod_FlameThrower_3Boss_ALT2") == 0) price = 1000;
	else if (stricmp(preset,"CnC_Nod_Minigunner_0") == 0) price = 0;
	else if (stricmp(preset,"CnC_Nod_Minigunner_1Off") == 0) price = 175;
	else if (stricmp(preset,"CnC_Nod_Minigunner_2SF") == 0) price = 500;
	else if (stricmp(preset,"CnC_Nod_Minigunner_3Boss") == 0) price = 1000;
	else if (stricmp(preset,"CnC_Nod_Minigunner_3Boss_ALT2") == 0) price = 1000;
	else if (stricmp(preset,"CnC_Nod_RocketSoldier_0") == 0) price = 0;
	else if (stricmp(preset,"CnC_Nod_RocketSoldier_1Off") == 0) price = 225;
	else if (stricmp(preset,"CnC_Nod_RocketSoldier_2SF") == 0) price = 450;
	else if (stricmp(preset,"CnC_Nod_RocketSoldier_3Boss") == 0) price = 1000;
	else if (stricmp(preset,"CnC_Nod_RocketSoldier_3Boss_ALT2") == 0) price = 1000;
	else if (stricmp(preset,"CnC_Nod_Technician_0") == 0) price = 350;
	else if (stricmp(preset,"CnC_Sydney_PowerSuit") == 0) price = 1000;
	else if (stricmp(preset,"CnC_Sydney_PowerSuit_ALT2") == 0) price = 1000;
	else if (stricmp(preset,"CnC_Sydney") == 0) price = 150;

	return price;
}

void Game::buy_item(const char *preset, GameObject *buyer, int price, int type) {
	char msg[1028];
	int credits = (int)Commands->Get_Money(buyer);
	int PID = Get_Player_ID(buyer);
	if (price <= credits) {
		char name[256];
		ini_main->Get_String("Preset",preset,preset,name,256);
		Commands->Give_Money(buyer,(float)price*-1,false);
		if (type == 1) {
			Commands->Give_Powerup(buyer,preset,true);
		} else if (type == 2) {
			Change_Character(buyer, preset);
		}
		sprintf(msg, "You have purchased a %s for %d credits!", name, price);
	} else {
		sprintf(msg, "You do not have enough money to purchase this!");
	}
	XpzCmds::ppage(0, PID, msg);
}

void Game::New_Player(int ID, const char *name, int band, float bhs) {
	HANDLE h = OpenMutex(MUTEX_ALL_ACCESS,FALSE,"pdb");
	DWORD d = WaitForSingleObject(h,5000);
	switch(d) {
	case WAIT_ABANDONED:
		break;
	case WAIT_OBJECT_0:
		if (players[ID].bandwidth != 0 && players[ID].time_joined != 0) Player_Leave(ID);
		players[ID] = Struct_Player(name,Get_Bandwidth(ID), bhs);
		break;
	case WAIT_TIMEOUT:
		break;
	}
	ReleaseMutex(h);

	HANDLE h2 = OpenMutex(MUTEX_ALL_ACCESS,FALSE,"hdb");
	DWORD d2 = WaitForSingleObject(h2,5000);
	Struct_Honor tmp2;
	switch(d2) {
	case WAIT_ABANDONED:
		break;
	case WAIT_OBJECT_0:
		tmp2.name = name;
		tmp2.vet_point = 0;
		tmp2.vet_rank = 0;
		Game::Set_Honor(name, tmp2);
		break;
	case WAIT_TIMEOUT:
		break;
	}
	ReleaseMutex(h2);
}

void Game::Get_Player(int ID, Struct_Player *tmp) {
	tmp->mod = -1;
	if (ID < 0 || ID > 128) return;
	bool working = false;
	HANDLE h = OpenMutex(MUTEX_ALL_ACCESS,FALSE,"pdb");
	DWORD d = WaitForSingleObject(h,1000);
	switch(d) {
	case WAIT_ABANDONED:
		break;
	case WAIT_OBJECT_0:
		*tmp = players[ID];
		working = true;
		break;
	case WAIT_TIMEOUT:
		break;
	}
	ReleaseMutex(h);
}

void Game::Set_Player(int ID, Struct_Player temp) {
	if (ID < 0 || ID > 128) return;
	HANDLE h = OpenMutex(MUTEX_ALL_ACCESS,FALSE,"pdb");
	DWORD d = WaitForSingleObject(h,1000);
	switch(d) {
	case WAIT_ABANDONED:
		break;
	case WAIT_OBJECT_0:
		players[ID] = temp;
		break;
	case WAIT_TIMEOUT:
		break;
	}
	ReleaseMutex(h);
}

void Game::Grant_Exp(int ID, double ammount) {
	if (ID < 0 || ID > 128) return;
	HANDLE h = OpenMutex(MUTEX_ALL_ACCESS,FALSE,"pdb");
	DWORD d = WaitForSingleObject(h,20);
	switch(d) {
	case WAIT_ABANDONED:
		break;
	case WAIT_OBJECT_0:
		players[ID].exp_pending += ammount;
		break;
	case WAIT_TIMEOUT:
		break;
	}
	ReleaseMutex(h);
}

int Game::true_rand(int min, int max) {
	int i = (int)(max * rand() / (RAND_MAX + 1.0)) + min;
	return i;
}

Struct_Honor Game::Get_Honor(std::string name) {
	Struct_Honor tmp;
	tmp.vet_rank = -1;
	bool working = false;
	Struct_Honor temp;
	HANDLE h = OpenMutex(MUTEX_ALL_ACCESS,FALSE,"hdb");
	DWORD d = WaitForSingleObject(h,20);
	vector<Struct_Honor>::iterator upto;
	switch(d) {
	case WAIT_ABANDONED:
		break;
	case WAIT_OBJECT_0:
		for(upto=hplayers.begin(); upto!=hplayers.end(); ++upto) {
			if (stricmp(upto->name.c_str(), name.c_str()) == 0) {
				working = true;
				break;
			}
		}
		break;
	case WAIT_TIMEOUT:
		break;
	}
	ReleaseMutex(h);

	if (working == true) return temp;
	else return tmp;
}

void Game::Set_Honor(std::string name, Struct_Honor temp) {
	Struct_Honor tmp;
	HANDLE h = OpenMutex(MUTEX_ALL_ACCESS,FALSE,"hdb");
	DWORD d = WaitForSingleObject(h,20);

	vector<Struct_Honor>::iterator upto;
	bool working = false;
	switch(d) {
	case WAIT_ABANDONED:
		break;
	case WAIT_OBJECT_0:
		for(upto=hplayers.begin(); upto!=hplayers.end(); ++upto) {
			if (stricmp(upto->name.c_str(), name.c_str()) == 0) {
				hplayers.erase(upto);
				hplayers.push_back(temp);
				working = true;
				break;
			}
		}
		if (working == false) hplayers.push_back(temp);
		break;
	case WAIT_TIMEOUT:
		break;
	}
	ReleaseMutex(h);
}

void Game::Reset_Honor_All() {
	vector<Struct_Honor>::iterator upto;

	HANDLE h = OpenMutex(MUTEX_ALL_ACCESS,FALSE,"hdb");
	DWORD d = WaitForSingleObject(h,1000);
	switch(d) {
	case WAIT_ABANDONED:
		break;
	case WAIT_OBJECT_0:
		for(upto=hplayers.begin(); upto!=hplayers.end(); ++upto) {
			upto->vet_rank = 0;
			upto->vet_point = 0;
		}
		break;
	case WAIT_TIMEOUT:
		break;
	}
	ReleaseMutex(h);
}

const char *Game::GetIconBone(const char *Preset, int IconNum) {
	if (IconNum == 1) {
		if (strstr(Preset,"CnC_Nod_Buggy")) return "muzzlea0";
		else if (strstr(Preset,"CnC_Nod_APC")) return "barrel";
		else if (strstr(Preset,"CnC_Nod_Mobile_Artillery")) return "muzzlea0";
		else if (strstr(Preset,"CnC_Nod_Light_Tank")) return "muzzlea0";
		else if (strstr(Preset,"CnC_Nod_Flame_Tank")) return "muzzlea0";
		else if (strstr(Preset,"CnC_Nod_Apache")) return "muzzleb0";
		else if (strstr(Preset,"CnC_GDI_Humm-vee")) return "muzzlea0";
		else if (strstr(Preset,"CnC_GDI_APC")) return "muzzlea0";
		else if (strstr(Preset,"CnC_GDI_MRLS")) return "muzzlea0";
		else if (strstr(Preset,"CnC_GDI_Medium_Tank")) return "muzzlea0";
		else if (strstr(Preset,"CnC_GDI_Mammoth_Tank")) return "muzzleb0";
		else if (strstr(Preset,"CnC_GDI_Orca")) return "muzzlea0";
	} else if (IconNum == 2) {
		if (strstr(Preset,"CnC_Nod_Flame_Tank")) return "muzzlea1";
		else if (strstr(Preset,"CnC_Nod_Apache")) return "muzzleb1";
		else if (strstr(Preset,"CnC_GDI_MRLS")) return "barrel";
		else if (strstr(Preset,"CnC_GDI_Mammoth_Tank")) return "muzzleb1";
		else if (strstr(Preset,"CnC_GDI_Orca")) return "muzzlea1";
	}
	return NULL;
}

void Game::DropWeapon(const char *preset, Vector3 pos) {
	if (last_drop_pos.X != pos.X && last_drop_pos.Y != pos.Y && last_drop_pos.Z != pos.Z) {
		last_drop_pos = pos;
		char drop1[256], drop2[256];
		int drops = 1, level = Game::Validate_Soldier(preset);
		strcpy(drop1, "POW_Armor_025");
		if (stricmp(preset, "CnC_GDI_MiniGunner_0") == 0) strcpy(drop1, "POW_AutoRifle_Player");
		else if (stricmp(preset, "CnC_Nod_Minigunner_0") == 0) strcpy(drop1, "POW_AutoRifle_Player_Nod");
		else if (stricmp(preset, "CnC_GDI_MiniGunner_1Off") == 0) strcpy(drop1, "POW_Chaingun_Player");
		else if (stricmp(preset, "CnC_Nod_MiniGunner_1Off") == 0) strcpy(drop1, "POW_Chaingun_Player_Nod");
		else if (stricmp(preset, "CnC_Nod_FlameThrower_1Off") == 0) strcpy(drop1, "POW_ChemSprayer_Player");
		else if (stricmp(preset, "CnC_Nod_FlameThrower_0") == 0) strcpy(drop1, "POW_Flamethrower_Player");
		else if (stricmp(preset, "CnC_GDI_Grenadier_0") == 0) strcpy(drop1, "POW_GrenadeLauncher_Player");
		else if (stricmp(preset, "CnC_Nod_RocketSoldier_2SF") == 0) strcpy(drop1, "POW_LaserChaingun_Player");
		else if (stricmp(preset, "CnC_Nod_FlameThrower_2SF") == 0) strcpy(drop1, "POW_LaserRifle_Player");
		else if (stricmp(preset, "CnC_Nod_Technician_0") == 0) {
			drops = 2;
			strcpy(drop1, "CnC_MineProximity_05");
			strcpy(drop2, "CnC_Weapon_RepairGun_Player_Special");
		} else if (stricmp(preset, "CnC_GDI_Engineer_2SF") == 0) {
			drops = 2;
			strcpy(drop1, "CnC_MineProximity_05");
			strcpy(drop2, "CnC_Weapon_RepairGun_Player_Special");
		} else if (stricmp(preset, "CnC_Nod_Engineer_0") == 0) strcpy(drop1, "CnC_POW_MineRemote_02");
		else if (stricmp(preset, "CnC_GDI_Engineer_0") == 0) strcpy(drop1, "CnC_POW_MineRemote_02");
		else if (stricmp(preset, "CnC_Sydney_PowerSuit") == 0) strcpy(drop1, "POW_PersonalIonCannon_Player");
		else if (stricmp(preset, "CnC_Nod_RocketSoldier_3Boss") == 0) strcpy(drop1, "POW_Railgun_Player");
		else if (stricmp(preset, "CnC_Nod_Minigunner_3Boss") == 0) strcpy(drop1, "POW_RamjetRifle_Player");
		else if (stricmp(preset, "CnC_GDI_MiniGunner_3Boss") == 0) strcpy(drop1, "POW_RamjetRifle_Player");
		else if (stricmp(preset, "CnC_GDI_RocketSoldier_1Off") == 0) strcpy(drop1, "POW_RocketLauncher_Player");
		else if (stricmp(preset, "CnC_Nod_RocketSoldier_1Off") == 0) strcpy(drop1, "POW_RocketLauncher_Player");
		else if (stricmp(preset, "CnC_GDI_RocketSoldier_2SF") == 0) strcpy(drop1, "CnC_POW_RocketLauncher_Player");
		else if (stricmp(preset, "CnC_GDI_RocketSoldier_0") == 0) strcpy(drop1, "POW_Shotgun_Player");
		else if (stricmp(preset, "CnC_Nod_RocketSoldier_0") == 0) strcpy(drop1, "POW_Shotgun_Player");
		else if (stricmp(preset, "CnC_GDI_MiniGunner_2SF") == 0) strcpy(drop1, "POW_SniperRifle_Player");
		else if (stricmp(preset, "CnC_Nod_Minigunner_2SF") == 0) strcpy(drop1, "POW_SniperRifle_Player_Nod");
		else if (stricmp(preset, "CnC_Sydney") == 0) strcpy(drop1, "POW_TiberiumAutoRifle_Player");
		else if (stricmp(preset, "CnC_Nod_Minigunner_2SF") == 0) strcpy(drop1, "POW_SniperRifle_Player_Nod");
		else if (stricmp(preset, "CnC_GDI_Grenadier_2SF") == 0) strcpy(drop1, "POW_TiberiumFlechetteGun_Player");
		else if (stricmp(preset, "CnC_Ignatio_Mobius") == 0) strcpy(drop1, "POW_VoltAutoRifle_Player");
		else if (stricmp(preset, "CnC_Nod_FlameThrower_3Boss") == 0) strcpy(drop1, "CnC_POW_VoltAutoRifle_Player_Nod");
		int drops2 = drops + level;
		int rnd = Game::true_rand(1,drops2);
		GameObject *dropped = 0;
		if (rnd > drops) {
			if (level < 4) dropped = Commands->Create_Object("POW_Armor_025", pos);
			else dropped = Commands->Create_Object("POW_Armor_050", pos);
		} else if (rnd == 1) {
			dropped = Commands->Create_Object(drop1, pos);
		} else if (rnd == 2 && drops >= 2) {
			dropped = Commands->Create_Object(drop2, pos);
		}
		if (dropped) Commands->Attach_Script(dropped,"Xpz_Drop_Weapon","");
	}
}

void Game::Pickup_Snd(GameObject *sender, const char *wname) {
	char snd[256];
	if (stricmp(wname,"CnC_POW_MineRemote_02") == 0) strcpy(snd,"m00pac4_aqob0004i1evag_snd.wav");
	else if (stricmp(wname,"POW_AutoRifle_Player") == 0) strcpy(snd,"m00pwar_aqob0004i1evag_snd.wav");
	else if (stricmp(wname,"POW_AutoRifle_Player_Nod") == 0) strcpy(snd,"m00pwar_aqob0004i1evag_snd.wav");
	else if (stricmp(wname,"POW_Chaingun_Player") == 0) strcpy(snd,"m00pwcg_aqob0004i1evag_snd.wav");
	else if (stricmp(wname,"POW_Chaingun_Player_Nod") == 0) strcpy(snd,"m00pwcg_aqob0004i1evag_snd.wav");
	else if (stricmp(wname,"POW_ChemSprayer_Player") == 0) strcpy(snd,"m00pwcs_aqob0004i1evag_snd.wav");
	else if (stricmp(wname,"POW_Flamethrower_Player") == 0) strcpy(snd,"m00pwft_aqob0001i1evag_snd.wav");
	else if (stricmp(wname,"POW_GrenadeLauncher_Player") == 0) strcpy(snd,"m00pwgl_aqob0004i1evag_snd.wav");
	else if (stricmp(wname,"POW_LaserChaingun_Player") == 0) strcpy(snd,"m00pwlc_aqob0004i1evag_snd.wav");
	else if (stricmp(wname,"POW_LaserRifle_Player") == 0) strcpy(snd,"m00pwlr_aqob0004i1evag_snd.wav");
	else if (stricmp(wname,"POW_RepairGun_Player") == 0) strcpy(snd,"m00pwrp_aqob0001i1evag_snd.wav");
	else if (stricmp(wname,"CnC_Weapon_RepairGun_Player_Special") == 0) strcpy(snd,"m00pwrp_aqob0001i1evag_snd.wav");
	else if (stricmp(wname,"POW_PersonalIonCannon_Player") == 0) strcpy(snd,"m00pwpi_aqob0004i1evag_snd.wav");
	else if (stricmp(wname,"POW_Railgun_Player") == 0) strcpy(snd,"m00pwrg_aqob0004i1evag_snd.wav");
	else if (stricmp(wname,"POW_RamjetRifle_Player") == 0) strcpy(snd,"m00pwrj_aqob0004i1evag_snd.wav");
	else if (stricmp(wname,"POW_RocketLauncher_Player") == 0) strcpy(snd,"m00pwrl_aqob0004i1evag_snd.wav");
	else if (stricmp(wname,"CnC_POW_RocketLauncher_Player") == 0) strcpy(snd,"m00pwrl_aqob0004i1evag_snd.wav");
	else if (stricmp(wname,"POW_Shotgun_Player") == 0) strcpy(snd,"m00pwps_aqob0004i1evag_snd.wav");
	else if (stricmp(wname,"POW_SniperRifle_Player") == 0) strcpy(snd,"m00pwsr_aqob0004i1evag_snd.wav");
	else if (stricmp(wname,"POW_SniperRifle_Player_Nod") == 0) strcpy(snd,"m00pwsr_aqob0004i1evag_snd.wav");
	else if (stricmp(wname,"POW_TiberiumAutoRifle_Player") == 0) strcpy(snd,"m00pwtr_aqob0004i1evag_snd.wav");
	else if (stricmp(wname,"POW_TiberiumFlechetteGun_Player") == 0) strcpy(snd,"m00pwtf_aqob0004i1evag_snd.wav");
	else if (stricmp(wname,"POW_VoltAutoRifle_Player")) strcpy(snd,"m00pwvr_aqob0004i1evag_snd.wav");
	else if (stricmp(wname,"CnC_POW_VoltAutoRifle_Player_Nod") == 0) strcpy(snd,"m00pwvr_aqob0004i1evag_snd.wav");
	else strcpy(snd,"m00pc$$_aqob0002i1evag_snd.wav");
	Create_2D_WAV_Sound_Player(sender,snd);
}

bool Game::bind(int pid, GameObject *tank) {
	if (!tank || tank == 0) return false;
	char temp[1024];
	int tid = Commands->Get_ID(tank);
	int owner = Game::Veh_Owner(tid);
	if (owner == 0) {
		int done = 0;
		HANDLE h = OpenMutex(MUTEX_ALL_ACCESS,FALSE,"bind");
		DWORD d = WaitForSingleObject(h,1000);
		switch(d) {
		case WAIT_ABANDONED:
			break;
		case WAIT_OBJECT_0:
			if (bound_vehs[pid].tank_id != 0) done = 2;
			else done = 1;
			bound_vehs[pid].tank_id = tid;
			break;
		case WAIT_TIMEOUT:
			break;
		}
		ReleaseMutex(h);
	
		if (done == 1) {
			sprintf(temp, "This %s has been bound to you.", Get_Translated_Preset_Name(tank));
			XpzCmds::ppage(0,pid,temp);
		} else if (done == 2) {
			sprintf(temp, "You your previous vehicle has been unbound. This %s has been bound to you.", Get_Translated_Preset_Name(tank));
			XpzCmds::ppage(0,pid,temp);
		}
		return true;
	} else {
		sprintf(temp, "This %s has already has an owner.", Get_Translated_Preset_Name(tank));
		XpzCmds::ppage(0,pid,temp);
		return false;
	}
}

bool Game::unbind(int pid, std::string reason) {
	bool done = false;
	HANDLE h = OpenMutex(MUTEX_ALL_ACCESS,FALSE,"bind");
	DWORD d = WaitForSingleObject(h,1000);
	switch(d) {
	case WAIT_ABANDONED:
		break;
	case WAIT_OBJECT_0:
		bound_vehs[pid].tank_id = 0;
		done = true;
		break;
	case WAIT_TIMEOUT:
		break;
	}
	ReleaseMutex(h);

	if (done == true) {
		std::string temp = "Your vehicle has been unbound";
		if (strlen(reason.c_str()) > 0) {
			temp += " because ";
			temp += reason.c_str();
		}
		XpzCmds::ppage(0,pid,temp.c_str());
		return true;
	} else return false;
}

int Game::Veh_Owner(int tank_id) {
	int max_pid = GetMaxPlayerID(), i = 1;
	bool done = false;
	HANDLE h = OpenMutex(MUTEX_ALL_ACCESS,FALSE,"bind");
	DWORD d = WaitForSingleObject(h,1000);
	switch(d) {
	case WAIT_ABANDONED:
		break;
	case WAIT_OBJECT_0:
		for (i; i <= max_pid; i++) {
			if (bound_vehs[i].tank_id == tank_id) {
				done = true;
				break;
			}
		}
		break;
	case WAIT_TIMEOUT:
		break;
	}
	ReleaseMutex(h);

	if (done == true) return i;
	else return 0;
}

int Game::Get_Veh_Owner(int pid) {
	HANDLE h = OpenMutex(MUTEX_ALL_ACCESS,FALSE,"bind");
	DWORD d = WaitForSingleObject(h,1000);
	switch(d) {
	case WAIT_ABANDONED:
		break;
	case WAIT_OBJECT_0:
		return bound_vehs[pid].tank_id;
		break;
	case WAIT_TIMEOUT:
		break;
	}
	ReleaseMutex(h);

	return 0;
}

std::string Game::phrase_map(std::string map_name) {
	map_name.erase(0,4);
	map_name.erase(map_name.size() - 4, map_name.size());
	string::size_type loc = map_name.find("_", 0);
	int upto = 0;
	while (loc != string::npos) {
		upto++;
		map_name.replace(loc, 1, " ");
		loc = map_name.find("_", upto);
	}
	return map_name;
}

int Game::within_rtc(std::string name, int team) {
	vector<std::string> teh_list;
	vector<std::string>::iterator upto;
	if (team == 0) teh_list = rtc_nod;
	else if (team == 1) teh_list = rtc_gdi;
	else return 0;
	int num = 0;

	if (teh_list.empty() == true) return 0;
	for(upto=teh_list.begin(); upto!=teh_list.end(); ++upto) {
		num++;
		if (stricmp(upto->c_str(), name.c_str()) == 0) {
			return num;
		}
	}
	return 0;
}

void Game::Defuse_All(std::string name) {
	int pid = Get_Player_ID(Get_GameObj_By_Player_Name(name.c_str()));
	Disarm_All_C4(pid);
	Disarm_All_Proxy_C4(pid);
	Disarm_Beacons(pid);
}

void Irc::Send_Raw(const char *data) {
	if (ini_main->Get_Bool("irc","enable",false) == true) T_IRC->add_task(task(1, data));
}

void Irc::Send_Chan(const char *chan, const char *data) {
	if (ini_main->Get_Bool("irc","enable",false) == true) T_IRC->add_task(task(2, chan, data));
}

void Irc::Send_Chan2(int chan, const char *data, bool system_msg) {
	if (ini_main->Get_Bool("irc","enable",false) == true)  {
		char temp[2048];
		if (system_msg == true) sprintf(temp, "9%s", data);
		else strcpy(temp, data);
		if (chan < 0 || chan > 2) return;
		if (chan == 0) T_IRC->add_task(task(4, temp));
		if (chan == 1) T_IRC->add_task(task(5, temp));
		if (chan == 2) T_IRC->add_task(task(6, temp));
	}
}

void Irc::Send_Notice(const char *person, const char *data) {
	if (ini_main->Get_Bool("irc","enable",false) == true) T_IRC->add_task(task(3, person, data));
}

int Irc::Get_Irc_Rank(const char *name, int chan) {
	vector<Irc_Rank> temp1;
	bool working = false;
	HANDLE h = OpenMutex(MUTEX_ALL_ACCESS,FALSE,"chanrank");
	DWORD d = WaitForSingleObject(h,1000);
	switch(d) {
	case WAIT_ABANDONED:
		break;
	case WAIT_OBJECT_0:
		if (chan == 1) temp1 = chan_ranks;
		else if (chan == 2) temp1 = chan_ranks2;
		working = true;
		break;
	case WAIT_TIMEOUT:
		break;
	}
	ReleaseMutex(h);

	int rank = 0;
	if (working == true) {
		for(unsigned int ii=0; ii < temp1.size(); ii++) {
			if (stricmp(temp1[ii].name.c_str(), name) == 0) {
				rank = temp1[ii].rank;
				break;
			}
		}
	}
	return rank;
}

void RG::send_rg(const char *msg) {
	std::string base64 = XpzBase::base64_encode(reinterpret_cast<const unsigned char*>(msg), strlen(msg));
	if (ini_main->Get_Bool("rg","enable",false) == true) T_Renguard->add_task(task(1,base64.c_str()));
}

void RG::send_raw(const char *msg) {
	if (ini_main->Get_Bool("rg","enable",false) == true) T_Renguard->add_task(task(1,msg));
}

std::string RG::encode64(const char *msg) {
	return XpzBase::base64_encode(reinterpret_cast<const unsigned char*>(msg), strlen(msg)).c_str();
}


std::string RG::encode64_2(const char *msg) {
	char temp[2048];
	sprintf(temp, "%s\n", XpzBase::base64_encode(reinterpret_cast<const unsigned char*>(msg), strlen(msg)).c_str());
	return temp;
}

static inline bool XpzBase::is_base64(unsigned char c) {
	return (isalnum(c) || (c == '+') || (c == '/'));
}

std::string XpzBase::base64_encode(unsigned char const* bytes_to_encode, unsigned int in_len) {
	std::string ret;
	int i = 0;
	int j = 0;
	unsigned char char_array_3[3];
	unsigned char char_array_4[4];

	while (in_len--) {
		char_array_3[i++] = *(bytes_to_encode++);
		if (i == 3) {
			char_array_4[0] = (char_array_3[0] & 0xfc) >> 2;
			char_array_4[1] = ((char_array_3[0] & 0x03) << 4) + ((char_array_3[1] & 0xf0) >> 4);
			char_array_4[2] = ((char_array_3[1] & 0x0f) << 2) + ((char_array_3[2] & 0xc0) >> 6);
			char_array_4[3] = char_array_3[2] & 0x3f;
			for(i = 0; (i <4) ; i++) ret += base64_chars[char_array_4[i]];
			i = 0;
		}
	}

	if (i) {
		for(j = i; j < 3; j++) char_array_3[j] = '\0';
		char_array_4[0] = (char_array_3[0] & 0xfc) >> 2;
		char_array_4[1] = ((char_array_3[0] & 0x03) << 4) + ((char_array_3[1] & 0xf0) >> 4);
		char_array_4[2] = ((char_array_3[1] & 0x0f) << 2) + ((char_array_3[2] & 0xc0) >> 6);
		char_array_4[3] = char_array_3[2] & 0x3f;
		for (j = 0; (j < i + 1); j++) ret += base64_chars[char_array_4[j]];
		while((i++ < 3)) ret += '=';
	}
	return ret;
}

std::string XpzBase::base64_decode(std::string const &encoded_string) {
	int in_len = encoded_string.size();
	int i = 0;
	int j = 0;
	int in_ = 0;
	unsigned char char_array_4[4], char_array_3[3];
	std::string ret;

	while (in_len-- && ( encoded_string[in_] != '=') && is_base64(encoded_string[in_])) {
		char_array_4[i++] = encoded_string[in_]; in_++;
		if (i ==4) {
			for (i = 0; i <4; i++) char_array_4[i] = base64_chars.find(char_array_4[i]);
			char_array_3[0] = (char_array_4[0] << 2) + ((char_array_4[1] & 0x30) >> 4);
			char_array_3[1] = ((char_array_4[1] & 0xf) << 4) + ((char_array_4[2] & 0x3c) >> 2);
			char_array_3[2] = ((char_array_4[2] & 0x3) << 6) + char_array_4[3];
			for (i = 0; (i < 3); i++) ret += char_array_3[i];
			i = 0;
		}
	}

	if (i) {
		for (j = i; j <4; j++) char_array_4[j] = 0;
		for (j = 0; j <4; j++) char_array_4[j] = base64_chars.find(char_array_4[j]);
		char_array_3[0] = (char_array_4[0] << 2) + ((char_array_4[1] & 0x30) >> 4);
		char_array_3[1] = ((char_array_4[1] & 0xf) << 4) + ((char_array_4[2] & 0x3c) >> 2);
		char_array_3[2] = ((char_array_4[2] & 0x3) << 6) + char_array_4[3];
		for (j = 0; (j < i - 1); j++) ret += char_array_3[j];
	}
	return ret;
}

void XpzBase::ipNumToString(unsigned int ipnum, char *ipstring) {
#if 0
	/* Old implementation disabled. */
	char *name = (char*) &ipnum;

	int a,b,c,d;
	a = (unsigned char)name[0];
	b = (unsigned char)name[1];
	c = (unsigned char)name[2];
	d = (unsigned char)name[3];
	sprintf(ipstring,"%d.%d.%d.%d",a,b,c,d);
#endif
	if (ipnum && ipstring) {
		struct in_addr addr;
		memcpy(&addr, &ipnum, sizeof(ipnum));

		char *ipAddr = inet_ntoa(addr);
		if (ipAddr)
			strcpy(ipstring, ipAddr);
		else
			*ipstring = '\0';
	} else if (ipstring)
		*ipstring = '\0';
}

bool XpzBase::hostnameToIP(char *hostname, char *hostIP) {
#ifndef WIN32
	extern int h_errno;
#endif
	struct hostent* host;

	host = gethostbyname(hostname);

	if (!host) {
		unsigned a, b, c, d;
		int result = sscanf(hostname, "%u.%u.%u.%u", &a, &b, &c,&d);	
		printf("Unable to resolve hostname: %s\n",hostname);
		if (result == 0 || result == EOF) {
			sprintf(hostIP,"?.?.?.?");
			return false;
		}
		else {
			if (a > 255 || b > 255 || c > 255 || d > 255) {
				printf("Unable to resolve host name: %s \n", hostname); 
				sprintf(hostIP, "?.?.?.?");
				return false;
			}
			else {
				unsigned addr, addr2;

				addr = (a << 24) + ((b << 16) & 0x00FF0000) + ((c << 8) & 0x0000FF00) + (d & 0x000000FF);
				addr2 = htonl(addr);
				ipNumToString(addr2, hostIP);
				return true;
			}
		}
	}
	unsigned int* addr;
	addr = (unsigned int*) host->h_addr_list[0];
	ipNumToString(*addr, hostIP);
	return true;
}

bool XpzBase::is_ip(char *a, int *v) {
	char i, *b;
	unsigned long ak;

	for(i=0; i<4; ++i, ++a) {
		while(isspace((uc)*a) && *a!='\n') a++;
		if(!isdigit(*a)) return false;
		ak = strtoul(a, &b, 10);
		if(ak > 255) return false;
		if(i == 3) {
			a = b;
			if(!isspace((uc)*a) && *a != '\0') return false;
			v[i]=ak;
			return true;
		}
		for(a = b; isspace((uc)*a) && *a != '\n'; a++);
		if(*a!='.') return false;
		v[i]= ak;
	}
	return false;
}

void XpzBase::send2(SOCKET sock, const char *msg) {
	std::string buffer = "RG Sending: (";
	buffer += msg;
	buffer += ") ";
	buffer += XpzBase::base64_decode(msg);
	Irc::Send_Chan2(1,buffer.c_str());
	send(sock, msg, strlen(msg), 0);
}

double XpzBase::pow(double base_num, int pow_of) {
	if (pow_of < 0) return (double)0;
	if (pow_of == 0) return (double)1;
	double res_num = base_num;
	for (int i = 1; i <= pow_of; i++) res_num *= base_num;
	return res_num;
}

void XpzCmds::help(int type, std::string person, std::string cmd) {
	char temp[1024];
	if (cmd.empty() == true) {
		ini_main->Get_String("help", "main", "There is no help available for this command.", temp, 1024);
	} else {
		ini_main->Get_String("help", cmd.c_str(), "There is no help available for this command.", temp, 1024);
	}
	std::string tmp = "[XpzHelp]: ";
	tmp += temp;
	if (type == 1) {
		// Irc
		Irc::Send_Notice(person.c_str(),tmp.c_str());
	} else {
		// InGame
		XpzCmds::ppage(0, Get_Player_ID(Get_GameObj_By_Player_Name(person.c_str())),tmp.c_str());
	}
}

void XpzCmds::rules(int type, bool is_map) {
	char temp[1024];
	if (is_map) ini_maps->Get_String(The_Game()->MapName,"rules","There are no specific rules for this map.", temp, 1024);
	else ini_main->Get_String("main","rules","No cheating, no exploits.", temp, 1024);
	XpzCmds::msg(0,"NULL",temp);
}

// <kicker> has <type>ed <kicked> for: <reason> (Duration: <time>)
// Kick: (T_MySQL task No.8)
// param4 = type
// types:
// 1 - Qkick
// 2 - kick / tban
// 3 - ban
// 4 - ban ip
// 5 - kick ip / tban ip
// param = name/ip
// param2 = reason
// param3 = kicker
// param5 = player id
void XpzCmds::kick(std::string kicker, std::string reason, int type, int kicked, int time) {
	if (kicked < 1 && kicked > 128) return;
	std::string reason2 = Get_IP_Address(kicked);
	reason2 += " ";
	reason2 += reason;
	if (ini_main->Get_Bool("db","enable",false) == true) {
		int type2 = 0;
		if (type == 0) type2 = 1; // qkick
		if (type == 1) type2 = 2; // name kick
		if (type == 2) type2 = 3; // name ban
		T_MySQL->add_task(task(8,Get_Player_Name_By_ID(kicked),reason2.c_str(),kicker.c_str(),type2,time));
	}

	char action[256];
	if (type == 0) sprintf(action, "Qkicked");
	else if (type == 1 || type == 2) sprintf(action, "Banned for %d hours.", time/3600);
	else if (type == 3) sprintf(action, "Permanently Banned");

	char temp[1024], name[128];
	strcpy(name, Get_Player_Name_By_ID(kicked));
	sprintf(temp, "You have been %s by %s with the reason: %s", action, kicker.c_str(), reason.c_str());
	XpzCmds::ppage(1,kicked,temp);
	sprintf(temp, "%s is being %s by %s with the reason: %s", name, action, kicker.c_str(), reason.c_str());
	XpzCmds::msg(0,"Null",temp);
	sprintf(temp, "kick %d", kicked);
	Game::ConsoleI(temp);
	if (type == 0) {
		sprintf(temp, "allow %s", name);
		Game::ConsoleI(temp);
	}
}

void XpzCmds::kick(std::string kicker, std::string reason, int type, const char *name, int time) {
	if (!Get_GameObj_By_Player_Name(name) || stricmp("None", name) == 0) return;
	int kicked = Get_Player_ID(Get_GameObj_By_Player_Name(name));
	std::string reason2 = Get_IP_Address(kicked);
	reason2 += " ";
	reason2 += reason;
	if (ini_main->Get_Bool("db","enable",false) == true) {
		int type2 = 0;
		if (type == 0) type2 = 1; // qkick
		if (type == 1) type2 = 2; // name kick
		if (type == 2) type2 = 3; // name ban
		if (type == 3) type2 = 5; // ip kick
		if (type == 4) type2 = 4; // ip ban
		T_MySQL->add_task(task(11,name,reason2.c_str(),kicker.c_str(),type2,time));
	}

	char action[256];
	if (type == 0) sprintf(action, "Qkicked");
	else if (type == 1 || type == 3) sprintf(action, "Banned for %d hours.", time);
	else if (type == 2 || type == 4) sprintf(action, "Permanently Banned");

	char temp[1024];
	if (type == 3 || type == 4) {
		sprintf(temp, "%s is being %s by %s with the reason: %s", Get_IP_Address(kicked), action, kicker.c_str(), reason.c_str());
		XpzCmds::msg(0,"Null",temp);
	} else {
		sprintf(temp, "You have been %s by %s with the reason: %s", action, kicker.c_str(), reason.c_str());
		XpzCmds::ppage(1,kicked,temp);
		sprintf(temp, "%s is being %s by %s with the reason: %s", name, action, kicker.c_str(), reason.c_str());
		XpzCmds::msg(0,"Null",temp);
	}

	sprintf(temp, "kick %d", kicked);
	Game::ConsoleI(temp);
	if (type == 0) {
		sprintf(temp, "allow %s", name);
		Game::ConsoleI(temp);
	}
}

void XpzCmds::player(int type, int chan) {
	std::string t_nod, t_gdi;
	char temp[1024];
	int num = GetMaxPlayerID();
	while (num > 0) {
		if (Get_Team(num) == 0) {
			t_nod += ", ";
			t_nod += Get_Player_Name_By_ID(num);
		}
		num--;
	}
	t_nod.erase(0,2);
	sprintf(temp, "04Nod Players: %s", t_nod.c_str());
	Irc::Send_Chan2(chan,temp);
	num = GetMaxPlayerID();
	while (num > 0) {
		if (Get_Team(num) == 0) {
			t_gdi += ", ";
			t_gdi += Get_Player_Name_By_ID(num);
		}
		num--;
	}
	t_gdi.erase(0,2);
	sprintf(temp, "08GDI Players: %s", t_gdi.c_str());
	Irc::Send_Chan2(chan,temp);
}

void XpzCmds::player_info(int type, std::string sender, int id) {
	std::string name = Get_Player_Name_By_ID(id);
	char temp[1024], temp2[128];
	GameObject *obj = Get_GameObj_By_Player_Name(sender.c_str());

	sprintf(temp, "Information for: %s", name.c_str());
	if (type == 0) Irc::Send_Notice(sender.c_str(), temp);
	else XpzCmds::ppage(0, Get_Player_ID(obj), temp);

	ini_main->Get_String("Preset", Commands->Get_Preset_Name(obj), Commands->Get_Preset_Name(obj), temp2, 128);
	sprintf(temp, "Character: %s - HP: %d/%d - SP: %d/%d", temp2, (int)Commands->Get_Health(obj), (int)Commands->Get_Max_Health(obj), (int)Commands->Get_Shield_Strength(obj), (int)Commands->Get_Max_Shield_Strength(obj));
	if (type == 0) Irc::Send_Notice(sender.c_str(), temp);
	else XpzCmds::ppage(0, Get_Player_ID(obj), temp);

	sprintf(temp, "Kills: %d - Deaths: %d - Points: %d - Credits: %d", Get_Kills(id), Get_Deaths(id), (int)Get_Score(id), (int)Commands->Get_Money(obj));
	if (type == 0) Irc::Send_Notice(sender.c_str(), temp);
	else XpzCmds::ppage(0, Get_Player_ID(obj), temp);

	Struct_Player temp_pdb;
	Game::Get_Player(id, &temp_pdb);
	Struct_Honor temp_hdb = Game::Get_Honor(temp_pdb.name);
	sprintf(temp, "Honor Level: %d - Exp: %I64d - Vehicle Kills: %d - Building Kills: %d", temp_pdb.honor, temp_pdb.exp, temp_hdb.vkill, temp_hdb.bkill);
	if (type == 0) Irc::Send_Notice(sender.c_str(), temp);
	else XpzCmds::ppage(0, Get_Player_ID(obj), temp);
}

void XpzCmds::game_info(int type, int chan) {
	int sec = The_Game()->GameDuration_Seconds, time = 0, hour = 0;
	while (sec > 60) {
		time++;
		sec -= 60;
	}
	while (time > 60) {
		hour++;
		time -= 60;
	}
	char temp[1024];
	if (type == 0) {
		// !gi
		sprintf(temp,"Game Information"); // - Map: %s Players: %d\\%d - Game Time: %d hours, %d minutes and %d seconds - SFPS: %d", Map1, Get_Player_Count(), The_Game()->MaxPlayers, hour, time, sec, SFPS);
		Irc::Send_Chan2(chan, temp);
		sprintf(temp,"Map: %s", The_Game()->MapName);
		Irc::Send_Chan2(chan, temp);
		sprintf(temp,"Time Elapsed: %d hrs %d mins %d secs", hour, time, sec);
		Irc::Send_Chan2(chan, temp);
		sprintf(temp,"SFPS: %d", SFPS);
		Irc::Send_Chan2(chan, temp);
		sprintf(temp,"Nod: %d/%d players %d points (Destroyed Buildings: %d)", Get_Team_Player_Count(0), The_Game()->MaxPlayers, int(Get_Team_Score(0)), desNod);
		Irc::Send_Chan2(chan, temp);
		sprintf(temp,"GDI: %d/%d players %d points (Destroyed Buildings: %d)", Get_Team_Player_Count(1), The_Game()->MaxPlayers, int(Get_Team_Score(1)), desGDI);
		Irc::Send_Chan2(chan, temp);
	} else {
		// !sgi
		sprintf(temp,"Game Info:(11WOL) Map: %s 8GDI: %d/%d players %d points 4NOD: %d/%d players %d points %d hrs %d mins %d secs played SFPS: %d", The_Game()->MapName, Get_Team_Player_Count(1), The_Game()->MaxPlayers, int(Get_Team_Score(1)), Get_Team_Player_Count(0), The_Game()->MaxPlayers, int(Get_Team_Score(0)), hour, time, sec, SFPS);
		Irc::Send_Chan2(chan, temp);
	}
}

void XpzCmds::maps(int type, int id, int chan) {
	std::string maps;
	if (id == 0) {
		maps = "The next map will be: ";
		if (The_Game()->MapList[The_Game()->MapNumber+1] != NULL) maps += The_Game()->MapList[The_Game()->MapNumber+1];
		else maps += The_Game()->MapList[0];
	} else if (id == 1) {
		for (unsigned int i = 0; The_Game()->MapList[i][0] != 0 && i < 101; i++) {
			maps += ", ";
			if (The_Game()->MapNumber == i) maps += "[";
			maps += The_Game()->MapList[i];
			if (The_Game()->MapNumber == i) maps += "]";
		}
		maps.erase(0,2);
	} else if (id == 2) {
		maps = "The current map is: ";
		maps += The_Game()->MapName;
	}

	if (type == 0) Irc::Send_Chan2(chan, maps.c_str());
	else XpzCmds::msg(0,"NULL",maps);
}

void XpzCmds::showmods(int type, int chan) {
	int max_pid = GetMaxPlayerID();
	std::string list_nod("4Nod Moderators:  "), list_gdi("8GDI Moderators:  "), list_spec("14Spectating Moderators:  "), ingame("Ingame Moderators: ");
	int count_gdi = 0, count_nod = 0, count_spec = 0, count_ingame = 0;
	HANDLE h = OpenMutex(MUTEX_ALL_ACCESS,FALSE,"pdb");
	DWORD d = WaitForSingleObject(h,1000);
	if (d == WAIT_OBJECT_0) {		
		for (int i=1; i<=max_pid; i++) {
			if (Is_Playing(i) == true) {
				if (players[i].mod > 0) {
					int team = Get_Team(i);
					if (type == 0) {
						if (team == 0) {
							list_nod += players[i].name;
							list_nod += ", ";
							count_nod++;
						} else if (team == 1) {
							list_gdi += players[i].name;
							list_gdi += ", ";
							count_gdi++;
						} else {
							list_spec += players[i].name;
							list_spec += ", ";
							count_spec++;
						}
					} else {
						ingame += players[i].name;
						ingame += ", ";
					}
				}
			}
		}
	}
	ReleaseMutex(h);

	if (count_nod > 0) list_nod.erase(list_nod.length()-2,2);
	if (count_gdi > 0) list_gdi.erase(list_gdi.length()-2,2);
	if (count_spec > 0) list_spec.erase(list_spec.length()-2,2);
	if (count_ingame > 0) ingame.erase(ingame.length()-2,2);

	if (type == 0) {
		if (count_nod > 0) Irc::Send_Chan2(chan,list_nod.c_str());
		if (count_gdi > 0) Irc::Send_Chan2(chan,list_gdi.c_str());
		if (count_spec > 0) Irc::Send_Chan2(chan,list_spec.c_str());
	} else {
		XpzCmds::msg(0,"Null",ingame);
	}
}

void XpzCmds::mine_limit(int type, int chan) {
	char temp[1024];
	sprintf(temp, "The mine limit for %s is: %d", Game::phrase_map(The_Game()->MapName).c_str(), Get_Mine_Limit());
	if (type == 0) Irc::Send_Chan2(chan, temp);
	else XpzCmds::msg(0, "NULL", temp);
}

void XpzCmds::rg_check(int type, int id, int chan) {
	if (Is_Playing(id) == false) return; 
	Struct_Player tmp;
	Game::Get_Player(id, &tmp);
	char temp[1024];
	sprintf(temp, "%s's Renguard Stats: %s", Get_Player_Name_By_ID(id), tmp.rg == true ? "Active (ON)" : "InActive (OFF)");
	if (type == 0) {
		// Irc
		Irc::Send_Chan2(chan, temp);
	} else {
		// Ingame
		XpzCmds::ppage(0,chan,temp);
	}
}

void XpzCmds::buildings(int side, int chan) {
	if (side == -1) {
		Irc::Send_Chan2(chan, Get_Buildings(0,true));
		Irc::Send_Chan2(chan, Get_Buildings(1,true));
	} else Irc::Send_Chan2(chan, Get_Buildings(side,true));
}

void XpzCmds::vehicles(int chan) {
	Irc::Send_Chan2(chan, Get_Vehicles(0,true,true));
	Irc::Send_Chan2(chan, Get_Vehicles(1,true,true));
	Irc::Send_Chan2(chan, Get_Vehicles(-2,true,true));
}

void XpzCmds::donate(GameObject *from, GameObject *to, int ammount, bool everyone) {
	int p1 = Get_Player_ID(from);
	int money = (int)Get_Money(p1);
	char temp[1024];
	sprintf(temp, "You do not have %d credits to donate!", ammount);
	if (ammount > money) XpzCmds::ppage(0,p1,temp);
	else {
		if (everyone == true) {
			float donate = (float)(ammount / (Get_Team_Player_Count(Get_Team(p1))-1));
			Commands->Give_Money(from,(ammount+donate)*-1,false);
			Commands->Give_Money(from,donate,true);
			sprintf(temp, "TMSG %d [Share] Here, everyone have %d credits each! (total:%d)", Get_Team(p1), (int)donate);
			Game::ConsoleI(temp);
		} else {
			int p2 = Get_Player_ID(to);
			if (Get_Team(p1) != Get_Team(p2)) {
				sprintf(temp, "You may only donate to your team mates!");
				XpzCmds::ppage(0,p1,temp);
			} else {
				Commands->Give_Money(from,(float)ammount*-1,false);
				Commands->Give_Money(to,(float)ammount,false);
				sprintf(temp, "%s has just donated you %d credits!", Get_Player_Name_By_ID(p1), ammount);
				XpzCmds::ppage(0,p2,temp);
			}
		}
	}
}

void XpzCmds::msg(int type, std::string sender, std::string content) {
	char tmp[2048];
	if (stricmp(sender.c_str(), "NULL") == 0) sprintf(tmp, "msg %s", content.c_str());
	else sprintf(tmp, "msg (%s@IRC) %s", sender.c_str(), content.c_str());
	T_Handler->add_task(task(2, tmp));
}

void XpzCmds::page(std::string sender, std::string name, std::string content, int chan) {
	char tmp[2048];
	sprintf(tmp, "page %s (%s@%s): %s", name.c_str(), sender.c_str(), WideCharToChar(The_Game()->GameTitle.m_Buffer), content.c_str());
	T_Handler->add_task(task(2, tmp));
	sprintf(tmp, "9Page Sent to %s --> (%s@%s): %s", name.c_str(), sender.c_str(), WideCharToChar(The_Game()->GameTitle.m_Buffer), content.c_str());
	Irc::Send_Chan2(chan,tmp);
}

void XpzCmds::ppage(int type, std::string sender, int id, std::string content, int chan) {
	char tmp[2048];
	if (type == 0) sprintf(tmp, "ppage %d (%s@IRC): %s", id, sender.c_str(), content.c_str());
	else sprintf(tmp, "pamsg %d (%s@IRC): %s", id, sender.c_str(), content.c_str());
	T_Handler->add_task(task(2, tmp));
	sprintf(tmp, "9Ppage Sent to %s --> (%s@IRC): %s", Get_Player_Name_By_ID(id), sender.c_str(), content.c_str());
	Irc::Send_Chan2(chan,tmp);
}

void XpzCmds::ppage(int type, int id, std::string content) {
	char tmp[2048];
	if (type == 0) sprintf(tmp, "ppage %d (XpzElite): %s", id, content.c_str());
	else sprintf(tmp, "pamsg %d (XpzElite): %s", id, content.c_str());
	T_Handler->add_task(task(2, tmp));
}

void XpzCmds::unban(int type, std::string kicker, std::string person) {
	if (ini_main->Get_Bool("db","enable",false) == true) {
		char temp[1024];
		if (type == 1) T_MySQL->add_task(task(9,NULL,person.c_str(),kicker.c_str(),type));
		else {
			T_MySQL->add_task(task(9,person.c_str(),NULL,kicker.c_str(),type));
			sprintf(temp, "allow %s", person.c_str());
			Game::ConsoleI(temp);
		}
		sprintf(temp, "%s has been unbanned by %s.", person.c_str(), kicker.c_str());
		XpzCmds::msg(0,"Null",temp);
	}
}

std::string XpzMod::rank_name(int rank) {
	std::string rank_n;
	if (rank == 1) rank_n = "VIP";
	else if (rank == 2) rank_n = "Half-Moderator";
	else if (rank == 3) rank_n = "Moderator";
	else if (rank == 4) rank_n = "Administrator";
	else if (rank == 5) rank_n = "Owner";
	return rank_n;
}

void XpzMod::promote(int id, int rank, std::string flags) {
	char temp[1024];
	HANDLE h = OpenMutex(MUTEX_ALL_ACCESS,FALSE,"pdb");
	DWORD d = WaitForSingleObject(h,1000);
	switch(d) {
	case WAIT_ABANDONED:
		break;
	case WAIT_OBJECT_0:
		if (players[id].mod < rank) {
			players[id].mod = rank;
			sprintf(temp, "%s has been granted %s status!", Get_Player_Name_By_ID(id), XpzMod::rank_name(rank).c_str());
			XpzCmds::msg(0,"Null",temp);
		}
		if (stricmp(flags.c_str(), "null") != 0) players[id].mod_flags = flags;
		break;
	case WAIT_TIMEOUT:
		break;
	}
	ReleaseMutex(h);
}

void XpzMod::demote(int id) {
	char temp[1024];
	HANDLE h = OpenMutex(MUTEX_ALL_ACCESS,FALSE,"pdb");
	DWORD d = WaitForSingleObject(h,1000);
	switch(d) {
	case WAIT_ABANDONED:
		break;
	case WAIT_OBJECT_0:
		if (players[id].mod > 0) {
			sprintf(temp, "%s has had their %s status revoked!", Get_Player_Name_By_ID(id), XpzMod::rank_name(players[id].mod).c_str());
			players[id].mod = 0;
			XpzCmds::msg(0,"Null",temp);
		}
		players[id].mod_flags = "";
		break;
	case WAIT_TIMEOUT:
		break;
	}
	ReleaseMutex(h);
}

/* =================================================================================================
Tank info gathers
------------------------------------------------------------------------------------------------- */

void XpzElite_Tank::Created(GameObject *obj) {
	/*v_owner = 0;
	locked = 0;
	logos = 0;
	const char *ib1 = Game::GetIconBone(Commands->Get_Preset_Name(obj),1);
	const char *ib2 = Game::GetIconBone(Commands->Get_Preset_Name(obj),2);
	if (ib1) {
		lock_logo = Commands->Create_Object_At_Bone(obj,"Invisible_Object",ib1);
		Commands->Attach_To_Object_Bone(lock_logo,obj,ib1);
		logos = 1;
	}
	if (ib2) {
		lock_logo2 = Commands->Create_Object_At_Bone(obj,"Invisible_Object",ib2);
		Commands->Attach_To_Object_Bone(lock_logo2,obj,ib2);
		logos = 2;
	}*/
	//Commands->Start_Timer(obj,this,2.0f,1);
}

void XpzElite_Tank::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	/*int pid = 0;
	if (Is_Soldier(sender) == true) pid = Get_Player_ID(sender);
	if (pid == 0 && (param == 0 || !param)) return;
	v_owner = Game::Veh_Owner(Commands->Get_ID(obj));
	if (message == CUSTOM_EVENT_VEHICLE_ENTER) {
		if (locked == true) {
			if (Get_Vehicle_Occupant(obj,1) == sender) {
				Force_Occupant_Exit(obj,1);
				XpzCmds::ppage(0, Get_Player_ID(sender), "This vehicle is locked!");
			}
		}
		last_in = Get_Player_ID(sender);
	} else if (message == CUSTOM_EVENT_VEHICLE_EXIT) {
	} else if (message == CUSTOM_XPZ_EVENT_LOCK) {
		if ((v_owner == 0 || v_owner == pid) && locked == false) {
			if (Game::bind(pid,obj) == true) {
				locked = true;
				if (logos > 0) Commands->Set_Model(lock_logo,"p_keycrd_red");
				if (logos > 1) Commands->Set_Model(lock_logo2,"p_keycrd_red");
				XpzCmds::ppage(0, pid, "This vehicle has been locked by you.");
			}
		} else XpzCmds::ppage(0, pid, "This vehicle is bound to someone else or is already locked.");
	} else if (message == CUSTOM_XPZ_EVENT_UNLOCK) {
		if (v_owner == pid && locked == true) {
			locked = false;
			XpzCmds::ppage(0, pid, "This vehicle has been unlocked.");
			if (logos > 0) Commands->Set_Model(lock_logo,"o_em_apc");
			if (logos > 1) Commands->Set_Model(lock_logo2,"o_em_apc");
		} else XpzCmds::ppage(0, pid, "This vehicle is either not bound to you or it's not locked.");
	} else if (message == CUSTOM_XPZ_EVENT_BIND) {
		if (param == 0) {
			if (Game::bind(pid,obj) == true) {
				if (logos > 0) Commands->Set_Model(lock_logo,"o_em_apc");
				if (logos > 1) Commands->Set_Model(lock_logo2,"o_em_apc");
			}
		} else {
			if (Game::bind(param,obj) == true) {
				if (logos > 0) Commands->Set_Model(lock_logo,"o_em_apc");
				if (logos > 1) Commands->Set_Model(lock_logo2,"o_em_apc");
			}	
		}
	} else if (message == CUSTOM_XPZ_EVENT_UNBIND) {
		if (Game::unbind(pid,"") == true) {
			if (logos > 0) Commands->Set_Model(lock_logo,"o_em_apc");
			if (logos > 1) Commands->Set_Model(lock_logo2,"o_em_apc");
			locked = false;
		}
	} else if (message == CUSTOM_XPZ_EVENT_FREE) {
		if (pid == v_owner || v_owner == 0) {
			if (logos > 0) Commands->Set_Model(lock_logo,"NULL");
			if (logos > 1) Commands->Set_Model(lock_logo2,"NULL");
			char temp[128];
			sprintf(temp, "tmsg %d Have this %s", pid, Get_Translated_Preset_Name(obj));
			std::string out = temp;
			GameObject *building = Find_Nearest_Building_By_Team(obj, Get_Team(pid));
			if (Commands->Get_Distance(Commands->Get_Position(obj), Commands->Get_Position(building))) {
				sprintf(temp, ", i'm near %s", Get_Translated_Preset_Name(building));
				out += temp;
			}
			Game::ConsoleI(out.c_str());
			if (pid == v_owner) Game::unbind(pid,"vehicle was freed");
			//Force_Occupants_Exit(obj);
		}
	}*/
}

void XpzElite_Tank::Killed(GameObject *obj, GameObject *shooter) {
	/*if (ini_main->Get_Bool("main", "shells", true) == false) return;
	char v_shell[128];
	ini_main->Get_String("shells", Commands->Get_Preset_Name(obj), 0, v_shell, 128);
	if (v_shell == 0) return;

	GameObject *the_shell = Commands->Create_Object(v_shell, Commands->Get_Position(obj));
	Commands->Set_Facing(the_shell, Commands->Get_Facing(obj));
	char param[1024];
	sprintf(param, "%s,%d,%d", Commands->Get_Preset_Name(obj), (int)Commands->Get_Max_Health(obj), (int)Commands->Get_Max_Shield_Strength(obj));
	Attach_Script_Once(the_shell, "XpzElite_Tank_Killed", param);*/
	
	int s_type = Get_Object_Type(shooter);
	if ((s_type == 0 && Get_Object_Type(obj) == 1) || (s_type == 1 && Get_Object_Type(obj) == 0)) {
		int killed_class = Game::Validate_Tank(Commands->Get_Preset_Name(obj)),
			killer_class = Game::Validate_Soldier(Commands->Get_Preset_Name(shooter)),
			killed_state = exp_veh_state,
			killer_state = exp_inf_state;

		if (Get_Vehicle(shooter) != 0) {
			killer_class = Game::Validate_Tank(Commands->Get_Preset_Name(Get_Vehicle(shooter)));
			killer_state = exp_veh_state;
		}

		double give_exp = (double)(((2*killed_class)-killer_class)*XpzBase::pow(EXPOTENTIAL, killer_class))/10+(2*killer_class) + (killed_state^2/killer_state);
		Game::Grant_Exp(Get_Player_ID(shooter), give_exp);
	}
}

void XpzElite_Tank::Damaged(GameObject *obj,GameObject *damager,float damage) {
	if (damage < 0.0f && damage >= -8.0f) {
		if (Get_Object_Type(damager) == Get_Object_Type(obj)) {
			double give_exp = (double)(damage * -1 * exp_repair_tank);
			Game::Grant_Exp(Get_Player_ID(damager), give_exp);
		}
	}
}

void XpzElite_Tank::Destroyed(GameObject *obj) {
	/*if (lock_logo) Commands->Destroy_Object(lock_logo);
	if (lock_logo2) Commands->Destroy_Object(lock_logo2);*/
}

void XpzElite_Tank::Timer_Expired(GameObject *obj, int number) {
	/*if (number == 1) {
		GameObject *player = Get_Vehicle_Owner(obj);
		if (player != NULL) {
			if (Is_Soldier(player) == true) {
				Commands->Send_Custom_Event(player , obj, CUSTOM_XPZ_EVENT_BIND, 0, 0);
			}
		}
	}*/
}

void XpzElite_Tank_Killed::Created(GameObject *obj) {
	/*needed = (int)((Commands->Get_Max_Health(obj) + Commands->Get_Max_Shield_Strength(obj)) * (ini_main->Get_Int("main","shell_respawn",10) / 100));
	if (Get_Int_Parameter("HP")) Set_Max_Health(obj, (float)Get_Int_Parameter("HP"));
	if (Get_Int_Parameter("SP")) Set_Max_Shield_Strength(obj, (float)Get_Int_Parameter("SP"));
	Commands->Set_Health(obj, Commands->Get_Max_Health(obj)*(ini_main->Get_Int("main", "shell_create", 5)/100));
	Commands->Set_Shield_Strength(obj, Commands->Get_Max_Shield_Strength(obj)*(ini_main->Get_Int("main", "shell_create", 5)/100));
	Commands->Disable_Physical_Collisions(obj);*/
}

void XpzElite_Tank_Killed::Damaged(GameObject *obj,GameObject *damager,float damage) {
	/*if (damage >= 0 || !damager) return;
	if ((Commands->Get_Health(obj) + Commands->Get_Shield_Strength(obj)) >= needed) return;
	float facing = Commands->Get_Facing(obj);
	Vector3 position = Commands->Get_Position(obj);
	Commands->Apply_Damage(obj, 99999, "BLAMO", obj);
	position.Z += 0.1f;
	GameObject *newobj = Commands->Create_Object(Get_Parameter("PresetName"),position);
	Commands->Set_Facing(newobj, facing);
	float maxhealth = Commands->Get_Max_Health(newobj);
	float maxarmor = Commands->Get_Max_Shield_Strength(newobj);
	if (maxhealth) Commands->Set_Health(newobj,maxhealth * (ini_main->Get_Int("main","shell_spawn",10) / 100));
	if (maxarmor) Commands->Set_Shield_Strength(newobj,maxarmor * (ini_main->Get_Int("main","shell_spawn",10) / 100));
	Attach_Script_Once(newobj,"XpzElite_Tank","");
	if (Is_Soldier(damager) == true) Commands->Send_Custom_Event(damager, newobj, CUSTOM_XPZ_EVENT_BIND, 0, 0);*/
}

/* =================================================================================================
Player info gathers
------------------------------------------------------------------------------------------------- */

void XpzElite_Player::Created(GameObject *obj) {
	interval = ini_main->Get_Int("main", "interval", 60);
	if (ini_main->Get_Bool("db","enable",false) == true) Commands->Start_Timer(obj, this, 1, 1); // MySQL player updating
	Commands->Start_Timer(obj, this, 6.0f, 2); // Exp and honor level updating
}

void XpzElite_Player::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 999990) {
		if (ini_main->Get_Bool("db","enable",false) == true) T_MySQL->add_task(task(12,NULL,NULL,NULL,0,Get_Player_ID(obj)));
	}
}

void XpzElite_Player::Killed(GameObject *obj, GameObject *shooter) {
	char tmp[512], tmp2[512];
	if (obj == shooter) {
		sprintf(tmp, "%s%s has killed theirself", Get_Team(Get_Player_ID(shooter)) == 0 ? "04" : "08", Get_Player_Name(shooter));
		sprintf(tmp2, "%s with a %s as a %s", tmp, Get_Current_Weapon(shooter), Get_Translated_Preset_Name(shooter));
	} else if (Is_Soldier(shooter)) {
		sprintf(tmp, "%s%s has killed %s", Get_Team(Get_Player_ID(shooter)) == 0 ? "04" : "08", Get_Player_Name(shooter), Get_Player_Name(obj));
		sprintf(tmp2, "%s with a %s as a %s", tmp, Get_Current_Weapon(shooter), Get_Translated_Preset_Name(shooter));
	} else if (Is_A_Building(shooter)) {
		sprintf(tmp, "%s%s has killed %s", Get_Object_Type(shooter) == 0 ? "04" : "08", Get_Translated_Preset_Name(shooter), Get_Player_Name(obj));
		strcpy(tmp2,tmp);
	} else {
		sprintf(tmp, "%s%s was killed", Get_Team(Get_Player_ID(shooter)) == 0 ? "04" : "08", Get_Player_Name(obj));
		strcpy(tmp2,tmp);
	}
	Irc::Send_Chan2(1, tmp);
	Irc::Send_Chan2(2, tmp2);

	int s_type = Get_Object_Type(shooter);
	if ((s_type == 0 && Get_Object_Type(obj) == 1) || (s_type == 1 && Get_Object_Type(obj) == 0)) {
		int killed_class = Game::Validate_Soldier(Commands->Get_Preset_Name(obj)),
			killer_class = Game::Validate_Soldier(Commands->Get_Preset_Name(shooter)),
			killed_state = exp_inf_state,
			killer_state = exp_inf_state;

		if (Get_Vehicle(shooter) != 0) {
			killer_class = Game::Validate_Tank(Commands->Get_Preset_Name(Get_Vehicle(shooter)));
			killer_state = exp_veh_state;
		}

		double give_exp = (double)(((2*killed_class)-killer_class)*XpzBase::pow(EXPOTENTIAL, killer_class))/10+(2*killer_class) + (killed_state^2/killer_state);
		Game::Grant_Exp(Get_Player_ID(shooter), give_exp);
	}
}

void XpzElite_Player::Destroyed(GameObject *obj) {
	char tmp[512];
	sprintf(tmp, "%d", int(Get_Player_ID(obj)));
	Commands->Attach_Script(global, "XpzElite_Player_Killed", tmp);
	Game::DropWeapon(Commands->Get_Preset_Name(obj),Commands->Get_Position(obj));
	Struct_Player temp;
	int id = Get_Player_ID(obj);
	Game::Get_Player(id, &temp);
	temp.deaths = Get_Deaths(id);
	temp.kills = Get_Kills(id);
	temp.score = (int)Get_Score(id);
	Game::Set_Player(id, temp);
	T_Handler->add_task(task(6,NULL,NULL,NULL,0,Get_Player_ID(obj)));
}

void XpzElite_Player::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		T_MySQL->add_task(task(4,NULL,NULL,NULL,0,Get_Player_ID(obj)));
		Commands->Start_Timer(obj, this, (float)interval, 1);
	} else if (number == 2) {
		T_Handler->add_task(task(6,NULL,NULL,NULL,0,Get_Player_ID(obj)));
		Commands->Start_Timer(obj, this, 6.0f, 2);
	}
}

void XpzElite_Player_Killed::Created(GameObject *obj) {
	pid = Get_Int_Parameter("pid");
	Commands->Start_Timer(obj, this, 4, 1);
}

void XpzElite_Player_Killed::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		if (Is_Playing(pid) == false) {
			if (gameoverd == false) {
				Player_Leave(pid);
			} else {
				pleave.push(pid);
			}
		}
		Destroy_Script();
	}
}

void XpzElite_Player_Level::Created(GameObject *obj) {
	Commands->Start_Timer(obj, this, 0.0f, 1);
}

void XpzElite_Player_Level::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		int temp;
		while (int(pleave.size()) != 0) {
			temp = pleave.front();
			pleave.pop();
			if (Is_Playing(temp) == false) {
				Player_Leave(temp);
			}
		}
		Destroy_Script();
	}
}

void Xpz_Drop_Weapon::Created(GameObject *obj) {
	Commands->Start_Timer(obj,this,15.0f,1);
	Commands->Start_Timer(obj,this,0.0f,2);
	Commands->Start_Timer(obj,this,13.0f,2);
	Commands->Start_Timer(obj,this,14.0f,2);
	Commands->Start_Timer(obj,this,14.9f,2);
}

void Xpz_Drop_Weapon::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 1000000025) {
		Game::Pickup_Snd(sender, Commands->Get_Preset_Name(obj));
	}
}

void Xpz_Drop_Weapon::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		Commands->Expire_Powerup(obj);
		Commands->Destroy_Object(obj);
	} else if (number == 2) {
		Commands->Create_Object("Spawner Created Special Effect",Commands->Get_Position(obj));
	}
}

/* =================================================================================================
Building info gathers
------------------------------------------------------------------------------------------------- */

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Created(GameObject *obj) {
	if (ini_main->Get_Bool("db","enable",false) == true) {
		T_MySQL->add_task(task(5,NULL,NULL,NULL,0,Commands->Get_ID(obj)));
		interval = ini_main->Get_Int("main", "interval", 60);
		Commands->Start_Timer(obj, this, (float)interval, 1);
	}
}

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	
}

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Killed(GameObject *obj, GameObject *shooter) {
	int pid = Get_Player_ID(shooter);
	int team = Get_Team(pid);
	int des_tmp = 0;
	if (team == 0) des_tmp = desGDI;
	else if (team == 1) des_tmp = desNod;
	int b_count = Get_Building_Count_Team(pid);
	double give_exp = (double)(((b_count + des_tmp)/b_count)*50);
	Game::Grant_Exp(Get_Player_ID(shooter), give_exp);
}

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Damaged (GameObject *obj,GameObject *damager,float damage) {
	if (damage < 0.0f && damage >= -8.0f) {
		if (Get_Object_Type(damager) == Get_Object_Type(obj)) {
			double give_exp = (double)(damage * -1 * exp_repair);
			Game::Grant_Exp(Get_Player_ID(damager), give_exp);
		}
	}
}

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Destroyed(GameObject *obj) {
	if (Get_Object_Type(obj) == 1) desGDI++;
	else desNod++;
}

void M00_BUILDING_EXPLODE_NO_DAMAGE_DAK::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		T_MySQL->add_task(task(6,NULL,NULL,NULL,0,Commands->Get_ID(obj)));
		Commands->Start_Timer(obj, this, (float)interval, 1);
	}
}

/* =================================================================================================
Beacon info gathers
------------------------------------------------------------------------------------------------- */

void XpzElite_Beacon::Created(GameObject *obj) {
	life = (int)(Commands->Get_Shield_Strength(obj) + Commands->Get_Health(obj));
	Commands->Start_Timer(obj, this, 5.0f, 1);
}

void XpzElite_Beacon::Killed(GameObject *obj, GameObject *shooter) {
	GameObject *building = Find_Nearest_Building_By_Team(obj, Get_Object_Type(obj) == 0 ? 1 : 0);
	Vector3 pos1 = Commands->Get_Position(obj), pos2 = Commands->Get_Position(building);
	pos1.Z = 0;
	pos2.Z = 0;
	std::string location = " ";
	if (Commands->Get_Distance(pos1, pos2) < 28) {
		location = " at the ";
		location += Get_Translated_Preset_Name(building);
		location += " ";
	}
	char temp[1024];
	sprintf(temp, "tmsg %d The beacon%s has been defused.", Get_Player_ID(Get_Beacon_Planter(shooter)), location.c_str());
	Game::ConsoleI(temp);
}

void XpzElite_Beacon::Damaged(GameObject *obj,GameObject *damager,float damage) {
	if (damage < 0 && damage >= -8) {
		double give_exp = (double)(damage * -1 * (exp_beacon / life));
		Game::Grant_Exp(Get_Player_ID(damager), give_exp);
	}
}

void XpzElite_Beacon::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		GameObject *building = Find_Nearest_Building_By_Team(obj, Get_Object_Type(obj) == 0 ? 1 : 0);
		Vector3 pos1 = Commands->Get_Position(obj), pos2 = Commands->Get_Position(building);
		pos1.Z = 0;
		pos2.Z = 0;
		std::string location = " ";
		if (Commands->Get_Distance(pos1, pos2) < 28) {
			location = " at the ";
			location += Get_Translated_Preset_Name(building);
			location += " ";
		}
		char temp[1024];
		sprintf(temp, "tmsg %d I have planted a beacon%s. Cover me!", Get_Player_ID(Get_Beacon_Planter(obj)), location.c_str());
		Game::ConsoleI(temp);
	}
}

/* =================================================================================================
Time Keeper, Task Manager
------------------------------------------------------------------------------------------------- */

void XpzElite_Timer::Created(GameObject *obj) {
	last_sfps = The_Game()->FrameCount;
	int_sql = ini_main->Get_Int("main", "interval", 60);
	if (ini_main->Get_Bool("db","enable",false) == true) Commands->Start_Timer(obj, this, (float)int_sql, 1); // Sql main update
	Commands->Start_Timer(obj, this, 1.0f, 2); // SFPS counter
	Commands->Start_Timer(obj, this, 30.0f, 3); // Rules
	//Commands->Start_Timer(obj, this, 0, 0); // Empty
	Commands->Start_Timer(obj, this, (float)rtc_time, 5); // Request team change
}

void XpzElite_Timer::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		T_MySQL->add_task(task(1));
		Commands->Start_Timer(obj, this, (float)int_sql, 1);
	} else if (number == 2) {
		SFPS = (int)(The_Game()->FrameCount - last_sfps);
		last_sfps = The_Game()->FrameCount;
		Commands->Start_Timer(obj, this, 1.0f, 2);
	} else if (number == 3) {
		char temp[1024], temp2[1024];
		ini_maps->Get_String(The_Game()->MapName,"rules","There are no specific map rules.",temp,512);
		sprintf(temp2, "Map Rules for %s: %s", Game::phrase_map(The_Game()->MapName).c_str(), temp);
		XpzCmds::msg(0,"Null",temp2);
	} else if (number == 4) {
	} else if (number == 5) {
		if (rtc_enable == true) {
			rtc_enable = false;
			XpzCmds::msg(0, "Null", "Request team change time is now over. Requesting team changes has now been disabled until next round.");
		}
	}
}

/* =================================================================================================
Crate Manager
------------------------------------------------------------------------------------------------- */

void XpzElite_Crates::Created(GameObject *obj) {
	base_time = 0;
	var_time = 0;
	num_crates = 0;
	active = false;
	loaded = false;
	loaded2 = false;
	last_loc.X = 0;
	last_loc.Y = 0;
	last_loc.Z = 0;
	crate_id = 0;
	Commands->Start_Timer(obj, this, 0, 2);
}

void XpzElite_Crates::Timer_Expired(GameObject *obj, int number) {
	if (number == 1) {
		if (active == false) {
			// spawn new crate
			GameObject *obj2 = Commands->Create_Object("", last_loc);
			Attach_Script_Once(obj2,"XpzElite_Crate","");
			crate_id = Commands->Get_ID(obj2);
		} else {
			int timer_lim = base_time - var_time + Game::true_rand(0, var_time * 2);
			Commands->Start_Timer(obj, this, (float)timer_lim, 1);
		}
	} else if (number == 2) {
		HANDLE h;
		DWORD d;
		if (loaded == false) {
			h = OpenMutex(MUTEX_ALL_ACCESS,FALSE,"ms");
			d = WaitForSingleObject(h,100);
			if (d == WAIT_OBJECT_0) {
				loaded = true;
				base_time = map_setting.crate_time;
				var_time = map_setting.crate_var;
				num_crates = map_setting.crate_num;
				if (map_setting.loaded == -1) Destroy_Script();
				Commands->Start_Timer(obj, this, 1.0f, 1);
			}
			ReleaseMutex(h);
		}

		if (loaded2 == false) {
			h = OpenMutex(MUTEX_ALL_ACCESS,FALSE,"crate");
			d = WaitForSingleObject(h,100);
			if (d == WAIT_OBJECT_0) {
				loaded2 = true;
				in_crates = crate_list;
				Commands->Start_Timer(obj, this, 1.0f, 1);
			}
			ReleaseMutex(h);
		}

		if (loaded == false || loaded2 == false) Commands->Start_Timer(obj, this, 0, 2);
		else Commands->Start_Timer(obj, this, 0, 1);
	}
}

void XpzElite_Crates::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 9874657) {
		active = false;
		int timer_lim = base_time - var_time + Game::true_rand(0, var_time * 2);
		Commands->Start_Timer(obj, this, (float)timer_lim, 1);
	}
}

void XpzElite_Crate::Custom(GameObject *obj, int message, int param, GameObject *sender) {
	if (message == 1000000025) {
		Commands->Send_Custom_Event(obj,global,9874657,0,0);
		// Pickup stuff
	}
}

void m00_crate::Created(GameObject *obj) {
	// removes original yellow crates
	Commands->Destroy_Object(obj);
	Destroy_Script();
}

/* =================================================================================================
C4 Stuff
------------------------------------------------------------------------------------------------- */

void XpzElite_C4::Killed(GameObject *obj, GameObject *shooter) {
	double give_exp = exp_c4;
	Game::Grant_Exp(Get_Player_ID(shooter), give_exp);
}

/* =================================================================================================
Script Factory Declarations
------------------------------------------------------------------------------------------------- */

ScriptRegistrant<XpzElite_Tank> XpzElite_Tank_Registrant("XpzElite_Tank","");
ScriptRegistrant<XpzElite_Tank_Killed> XpzElite_Tank_Killed_Registrant("XpzElite_Tank_Killed","PresetName:string,HP:int,SP:int");
ScriptRegistrant<XpzElite_Player> XpzElite_Player_Registrant("XpzElite_Player","");
ScriptRegistrant<XpzElite_Player_Killed> XpzElite_Player_Killed_Registrant("XpzElite_Player_Killed","pid:string");
ScriptRegistrant<XpzElite_Player_Level> XpzElite_Player_Level_Registrant("XpzElite_Player_Level","");
ScriptRegistrant<Xpz_Drop_Weapon> Xpz_Drop_Weapon_Registrant("Xpz_Drop_Weapon","");
ScriptRegistrant<M00_BUILDING_EXPLODE_NO_DAMAGE_DAK> M00_BUILDING_EXPLODE_NO_DAMAGE_DAK_Registrant("M00_BUILDING_EXPLODE_NO_DAMAGE_DAK","");
ScriptRegistrant<XpzElite_Beacon> XpzElite_Beacon_Registrant("XpzElite_Beacon","");
ScriptRegistrant<XpzElite_Timer> XpzElite_Timer_Registrant("XpzElite_Timer","");
ScriptRegistrant<XpzElite_Crates> XpzElite_Crates_Registrant("XpzElite_Crates","");
ScriptRegistrant<XpzElite_Crate> XpzElite_Crate_Registrant("XpzElite_Crate","");
ScriptRegistrant<XpzElite_C4> XpzElite_C4_Registrant("XpzElite_C4","");
ScriptRegistrant<m00_crate> m00_crate_Registrant("m00_crate","");