#include "scripts.h"
#include <string>
#include <time.h>
#include <winsock2.h>
#include "engine.h"
#include "data.h"

bool check_int(int val) {
	if (val == 0) return false;
	else return true;
}

int recvtimeout(int socket, char *buf, int len, int timeout) {
    fd_set sfds;
    int n;
    struct timeval tv;

    FD_ZERO(&sfds);
    FD_SET(socket, &sfds);

    tv.tv_sec = timeout;
    tv.tv_usec = 0;

    n = select(socket+1, &sfds, NULL, NULL, &tv);
    if (n == 0) return -2;
    if (n == -1) return -1;
    return 1;
}

Struct_Map_Settings::Struct_Map_Settings() {
	this->bd_active = false;
	this->bd_num = 0;
	this->crate_num = 0;
	this->loaded = 0;
	this->crate_loaded = 0;
	this->bd_loaded = 0;
}

Struct_Player::Struct_Player() {
	this->bandwidth = 0;
	this->bhs = 0;
	this->commander = false;
	this->mod = 0;
	this->name = "";
	time_t seconds = time (NULL);
	this->time_joined = int(seconds);
	this->exp = 0;
	this->exp_pending = 0;
	this->honor = 1;
	this->rg = false;
}

Struct_Player::Struct_Player(const char *name, int band, float bhs) {
	this->bandwidth = band;
	this->bhs = bhs;
	this->commander = false;
	this->mod = 0;
	this->name = name;
	time_t seconds = time (NULL);
	this->time_joined = int(seconds);
	this->exp = 0;
	this->exp_pending = 0;
	this->honor = 1;
	this->rg = false;
}

Struct_Honor::Struct_Honor() {
	this->vet_point = 0;
	this->vet_rank = 0;
	this->vkill = 0;
	this->vkill_honor = 0;
	this->snipe_honor = 0;
	this->bkill = 0;
}

Socket::Socket() {
	iSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	connected = false;
}

Socket::Socket(const char *ip1, int port1) {
	Set1(ip1, port1);
}

void Socket::Set1(const char *ip1, int port1) {
	iSocket = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	connected = false;
	this->port = port1;
	strcpy(this->ip,ip1);
	iAddr.sin_port = htons(port1);
	iAddr.sin_family = AF_INET;
	iAddr.sin_addr.s_addr = inet_addr(this->ip);
}

void Socket::Set_Conn(const char *ip1, int port1) {
	this->port = port1;
	strcpy(this->ip,ip1);
}

bool Socket::Connect(int trys) {
	int trys2 = trys;
	while (this->connected == false && (trys2 > 0 || trys == 0)) {
		if (connect(this->iSocket, (SOCKADDR *)(&this->iAddr), sizeof(this->iAddr)) == 0) {
			this->connected = true;
			return this->connected;
		} else {
			this->connected = false;
		}
		if (trys != 0) trys2--;
	}
	return this->connected;
}

SOCKET Socket::Get_Socket() {
	return this->iSocket;
}

bool Socket::Get_Line(char *read1) {
	if (read1 == NULL) return false;
	char c=0;
	int i=0;
	int tempi = -2;
	char read[2048];
	read[0] = '\0';

	while(c != '\n') {
		tempi = recvtimeout(this->iSocket,&c,1,0);
		if (tempi == -2) break;
		if (tempi == -1) break;
		recv(this->iSocket,&c,1,0);
		if (c != '\n') {
			read[i]=c;
		} else {
			read[i]='\0';
		}
		if (c == 0) break;
		i++;
	}

	if (read[0] == '\0') {
		return false;
	} else {
		strcpy(read1, read);
		return true;
	}
}

bool Socket::HasConnectionDropped() {
	bool bConnDropped = false;
	int iRet = 0;
	bool bOK = true;

	struct timeval timeout = {0, 0};
	fd_set readSocketSet;

	FD_ZERO(&readSocketSet);
	FD_SET(this->iSocket, &readSocketSet);

	iRet = select(0, &readSocketSet, NULL, NULL, &timeout);
	bOK = (iRet > 0);

	if (bOK) bOK = FD_ISSET(this->iSocket, &readSocketSet);

	if (bOK) {
		CHAR szBuffer[1] = "";
		iRet = recv(this->iSocket, szBuffer, 1, MSG_PEEK );
		bOK = (iRet > 0);
		if(!bOK) {
			INT iError = WSAGetLastError();
			bConnDropped = ((iError == WSAENETRESET) || (iError == WSAECONNABORTED) || (iError == WSAECONNRESET) || (iError == WSAEINVAL) || (iRet == 0));
		}
	}

	this->connected = !bConnDropped;
    return bConnDropped;
}

bool Socket::IsConnected() {
	return this->connected;
}

void Socket::DisconnectSock() {
	closesocket(iSocket);
}

Struct_RG_Server::Struct_RG_Server() {
	this->ip = "";
	this->port = 0;
	this->con_stat = 0;
}

Struct_RG_Server::Struct_RG_Server(const char *ip, int port) {
	this->ip = ip;
	this->port = port;
	this->con_stat = 0;
}

Struct_Base_Defense::Struct_Base_Defense() {
	this->alive = false;
	this->construction = 0;
	this->credit = 0;
	this->loc.X = 0;
	this->loc.Y = 0;
	this->loc.Z = 0;
	this->side = 0;
	this->cost = 2000;
	this->preset = "Null";
	this->enabled = false;
	this->object_id = 0;
}

Struct_Base_Defense::Struct_Base_Defense(std::string preset, int side, int cost, Vector3 loc, bool start_construction) {
	this->alive = start_construction;
	this->construction = 0;
	this->cost = cost;
	this->credit = 0;
	this->loc = loc;
	this->preset = preset;
	this->side = side;
	this->enabled = false;
	this->object_id = 0;
	if (start_construction == true) this->build();
}

bool Struct_Base_Defense::stats() {
	return this->enabled;
}

void Struct_Base_Defense::enable() {
	this->enabled = true;
}

void Struct_Base_Defense::disable() {
	this->enabled = false;
}

bool Struct_Base_Defense::build() {
	if (this->enabled == false) return false;
	this->construction = 1;
	this->alive = true;
	this->credit = 0;
	this->object_id = Commands->Get_ID(Commands->Create_Object(this->preset.c_str(), this->loc));
	return true;
}

bool Struct_Base_Defense::destroy() {
	if (this->enabled == false) return false;
	if (this->alive == false) return false;
	Commands->Destroy_Object(Commands->Find_Object(this->object_id));
	return true;
}

int Struct_Base_Defense::cred(int amm) {
	this->credit += amm;
	if (this->cost <= this->credit) {
		this->build();
		this->credit -= this->cost;
	}
	return this->credit;
}