// Dynamic = changing (eg. each player)

bool check_int(int val);

/*
struct Structs {
	void lock() {
		
	}
	void unlock() {

	}
};

struct Struct_Settings : Structs {	// Main server Settings
	Struct_Settings();				// Constructor
	std::string prefex;				// Server Prefex
	std::string setting_prefex;		// Server settings prefex
	void load_map_list();			// Map list loader
	std::string maps[32];			// Map list
	int rebuy_cost;					// Extra base defence rebuy cost
	bool vshell;					// Vehicle shells enable
	int shell_rebuild;				// Percent shells will rebuild
};

struct Struct_MySQL_Settings : Structs {	// MySQL settings struct
	Struct_MySQL_Settings();				// Constructor
	char ip[16];							// MySQL server IP
	int port;								// MySQL server port
	std::string user;						// Login name
	std::string pass;						// Login Password
	std::string db_name;					// Database Name
	bool auto_setting;						// Auto configger server settings from online
};

struct Struct_IRC_Settings : Structs {	// IRC settings struct
	Struct_IRC_Settings();				// Constructor
};

struct Struct_Renguard_Settings : Structs {	// Renguard settings struct
	Struct_Renguard_Settings();				// Constructor
};

struct Struct_TeamSpeak_Settings : Structs {	// TeamSpeak settings struct
	Struct_TeamSpeak_Settings();				// Constructor
};
*/

struct Struct_Map_Settings {	// Map Settings
	Struct_Map_Settings();		// Constructor
	int crate_num;				// Number of crates registered
	int bd_num;					// Number of registered base defenses
	bool bd_active;				// Base defence active?
	int bd_chance;				// Chance % of map having base defence
	int crate_time;				// Base Crate spawn time
	int crate_var;				// Variation of the base spawn time
	Vector3 last_crate;			// Location of the last spawned crate
	bool crate_pending;			// If there is a current crate or not
	int loaded;					// Map information loaded? (-1)-disabled, 0-nothing;retry , 1-pending, 2-fully loaded
	int crate_loaded;			// Crate information loaded? (-1)-disabled, 0-nothing;retry , 1-pending, 2-fully loaded
	int bd_loaded;				// Base defence information loaded? (-1)-disabled, 0-nothing;retry , 1-pending, 2-fully loaded
};

struct Struct_Player {	// Player Struct (dynamic struct)
	Struct_Player();				// Constructor
	Struct_Player(const char *name, int band, float bhs); // Overloaded Constructor
	std::string name;				// Player Name
	int time_joined;				// CTime of player join
	bool commander;					// Commander status
	int mod;						// Moderator level
	std::string mod_flags;			// Moderator flags
	int bandwidth;					// Player bandwidth at join
	float bhs;						// Player BHS.dll version
	int updated;					// CTime of player's last update
	unsigned __int64 exp;			// Total Exp
	double exp_pending;				// Pending Exp
	int honor;						// Honor level
	bool rg;						// Renguard
	std::string rg_session;			// RG Session hash
	int deaths;						// Deaths
	int kills;						// Kills
	int score;						// Score
};

struct Struct_Honor {		// Honor / Veterancy struct  (dynamic struct)
	Struct_Honor();					// Constructor
	std::string name;				// Player Name
	int vet_rank;					// Veterancy ranking
	double vet_point;				// Veterancy points
	int snipe_honor;				// Honorable snipe kills
	int vkill_honor;				// Vehicle kill honor points
	int vkill;						// Vehicle kills
	int bkill;						// Building kills
};

class Socket {
private:
	SOCKET iSocket;
	SOCKADDR_IN iAddr;
	char ip[16];
	int port;
	bool connected;

public:
	Socket();
	Socket(const char *ip1, int port1);
	void Set1(const char *ip1, int port1);
	void Set_Conn(const char *ip1, int port1);
	bool Connect(int trys = 0);
	SOCKET Get_Socket();
	bool Get_Line(char *read1);
	bool HasConnectionDropped();
	bool IsConnected();
	void DisconnectSock();
};

struct Irc_Rank {
	std::string name;
	int rank;
};

struct Struct_Bind {
	int tank_id;
};

struct Struct_RG_Server {
	Struct_RG_Server();
	Struct_RG_Server(const char *ip, int port);
	std::string ip;
	int port;
	int con_stat;
	static const int DEAD = 0;
	static const int INIT = 1;
	static const int CONECTED = 2;
	static const int DISCONECTED = 3;
};

struct Struct_Base_Defense {
	Struct_Base_Defense();
	Struct_Base_Defense(std::string preset, int side, int cost, Vector3 loc, bool start_construction);
	bool stats();		// Returns the 'enabled' or 'disabled' status
	void enable();		// Enables this base defense
	void disable();		// Disables this base defense
	bool build();		// Creates the base defense (or starts the construction phase)
	bool destroy();		// Kills the base defence
	int cred(int amm);	// Change the current credits to the amount needed
	bool alive;			// Is this alive or dead? (in construction = true)
	int credit;			// How many credits in the pool
	int cost;			// How much it needs to be built
	Vector3 loc;		// Location
	int construction;	// Construction status (maybe use time based construction)
	int side;			// Which team is this defense is for
	std::string preset;	// Which preset this is
	bool enabled;		// Enabled status
	int object_id;		// Tracking for the object
};