#include <string>

char *Get_Objects_File() {
	return ObjectsAddress;
}

void Change_Objects_File(const char *Name) {
	memcpy((void*)ObjectsAddress,(void*)Name,3);
}

/*GameObject *Get_GameObj_By_Player_Name(const char *Name) {
	GenericSLNode *x = BaseGameObjList->HeadNode;
	while (x != 0) {
		GameObject *o = As_SoldierGameObj((GameObject *)x->NodeData);
		if (o != 0) {
			if (stricmp(Get_Player_Name(o),Name) == 0) return o;
		}
		x = x->NodeNext;
	}
	return 0;
}*/

std::string StringToUpper(std::string strToConvert) {
	for(unsigned int i=0;i<strToConvert.length();i++)
	{
		strToConvert[i] = toupper(strToConvert[i]);
	}
	return strToConvert;
}
 
std::string StringToLower(std::string strToConvert) {
	for(unsigned int i=0;i<strToConvert.length();i++) {
		strToConvert[i] = tolower(strToConvert[i]);
	}
	return strToConvert;
}

void Kill_Object_By_Preset(const char *Preset_Name) {
	GenericSLNode *x = BaseGameObjList->HeadNode;
	while (x)
	{
		GameObject *o = (GameObject *)x->NodeData;
		if (o && As_ScriptableGameObj(o))
		{
			if (!stricmp(Get_Definition_Name(Get_Player_ID(o)),Preset_Name))
			{
				if (Is_Script_Attached(o, "BDMain") == false) {
					Commands->Destroy_Object(o);
				}
			}
		}
		x = x->NodeNext;
	}
}

void Send_Custom_Vehicle(int message,GameObject *sender,int team) {
	if (!Commands->Get_ID(sender) || !sender) return;
	GenericSLNode *x = BaseGameObjList->HeadNode;
	while (x)
	{
		GameObject *o = As_ScriptableGameObj((GameObject *)x->NodeData);
		if (o)
		{
			if (Is_Vehicle(o) == true)
			{
				if ((Get_Object_Type(o) == team) || (team == 2))
				{
					Commands->Send_Custom_Event(sender,o,message,0,0);
				}
			}
		}
		x = x->NodeNext;
	}
}

void Send_Custom_Vehicle_All(int message,GameObject *sender) {
	if (!Commands->Get_ID(sender) || !sender) return;
	GenericSLNode *x = BaseGameObjList->HeadNode;
	while (x)
	{
		GameObject *o = As_ScriptableGameObj((GameObject *)x->NodeData);
		if (o)
		{
			if (Is_Vehicle(o) == true)
			{
				Commands->Send_Custom_Event(sender,o,message,0,0);
			}
		}
		x = x->NodeNext;
	}
}

GameObject *Find_Nearest_Building_By_Team(GameObject *obj, int team) {
	if (!Commands->Get_ID(obj) || !obj) return 0;
	float nearest = 99999;
	GameObject *obj2 = 0;
	GenericSLNode *x = BuildingGameObjList->HeadNode;
	while (x)
	{
		GameObject *o = As_BuildingGameObj((GameObject *)x->NodeData);
		if (o)
		{
			if (Get_Object_Type(o) == team) {
				Vector3 tmp2 = Commands->Get_Position(obj);
				Vector3 tmp3 = Commands->Get_Position(o);
				float tmp = Commands->Get_Distance(tmp2, tmp3);
				if (tmp < nearest) {
					nearest = tmp;
					obj2 = o;
				}
			}
		}
		x = x->NodeNext;
	}
	if (obj2) return obj2;
	else return 0;
}

void Damage_All_Objects_Area_Team_No_C4(float Damage,const char *Warhead,const Vector3 &Position,float Distance,GameObject *Host,GameObject *Damager, int Team) {
	if (!Commands->Get_ID(Host) || !Host)
	{
		return;
	}
	GenericSLNode *x = BaseGameObjList->HeadNode;
	while (x) 
	{
		GameObject *obj = (GameObject *)x->NodeData;
		if (obj && As_ScriptableGameObj(obj)) 
		{
			Vector3 ObjPosition = Commands->Get_Position(obj);
			Vector3 TestPosition = Position;
			ObjPosition.Z = 0;
			TestPosition.Z = 0;
			if ((Commands->Get_Distance(ObjPosition,TestPosition) <= Distance) && (Commands->Get_ID(obj) != Commands->Get_ID(Host)))
			{
				if (Get_Object_Type(obj) == Team && Is_C4(obj) == false && Is_Beacon(obj) == false) Commands->Apply_Damage(obj,Damage,Warhead,Damager);
			}
		}
		x = x->NodeNext;
	}
}

void Damage_Stealth(float ammount, char *warhead, GameObject *damager) {
	GenericSLNode *z = BaseGameObjList->HeadNode;
	while (z)
	{
		GameObject *obj = (GameObject *)z->NodeData;
		if (obj)
		{
			if (As_SoldierGameObj(obj) || Is_Vehicle(obj)) {
				if (Is_Stealth(obj) == true && Commands->Get_Health(obj) > 20) Commands->Apply_Damage(obj, ammount, warhead, damager);
			}
		}
		z = z->NodeNext;
	}
}